/* TACalAliP 

   pupose: calculate alignment parameters  to apply to NEDE to get GEDE           
   input:  pointer to OTR_nede, OTR_alig
   output: Grot[9],trans[3]               

   by Dirk Kruecker 17.8.99 
*/

#include <stdio.h>
#include "ledaC.h"
#include "wax/otr_db.h"
#include "math.h"

   
void TACalAliP(LedaTableRow(OTR_nede) *nederow,
               LedaTableRow(OTR_align)*alignrow,
               float Grot[9], float trans[3]){

     int i,j,k,idxG,idxN,idxRA;

/* rotation angles around x,y,z */
     float a=alignrow->ang[0];		
     float b=alignrow->ang[1];		
     float c=alignrow->ang[2];		
       
/* rotation matrix RA:=R_z(c)*R_y(b)*R_x(a)= */
     float RA[9]={cos(b)*cos(c),cos(b)*sin(c),-sin(b),
            -cos(a)*sin(c)+sin(a)*sin(b)*cos(c),cos(a)*cos(c)+sin(a)*sin(b)*sin(c),sin(a)*cos(b),
            sin(a)*sin(c)+cos(a)*sin(b)*cos(c),-sin(a)*cos(c)+cos(a)*sin(b)*sin(c),cos(a)*cos(b)
	    };
     float cog[3];
/* c.o.g. for nede */
     cog[0]=(nederow->sxmn+nederow->sxmx)/2;
     cog[1]=(nederow->symn+nederow->symx)/2;
     cog[2]=(nederow->zmin+nederow->zmax)/2;
/* GEDE_rot:=NEDE_rot*R_A */
     for(i=0;i<3;i++){
        for(k=0;k<3;k++){
	    idxG=i+k*3;
	    Grot[idxG]=0;
	    for(j=0;j<3;j++){
	       idxN=i+j*3;
	       idxRA=j+k*3;
	       Grot[idxG]=Grot[idxG]+(nederow->rot[idxN])*RA[idxRA];
	    }
	}
     }
           
/*   trans=GEDE_rot*N_transposed*(delt+c.o.g.)-c.o.g */     
/*   trans=GEDE_rot*(N_t*delt+(N_t-1)*c.o.g */
     for(i=0;i<3;i++){
        trans[i]=-cog[i];
        for(k=0;k<3;k++){
	  for(j=0;j<3;j++){
	     idxG=i+j*3;
	     idxN=k+j*3;
	     trans[i]=trans[i]+Grot[idxG]*(nederow->rot[idxN])*(alignrow->delt[k]+cog[k]);
	    }
	 }
     }
/* printing */
/*
     printf("TACalAliP: angles a=%f,b=%f,c=%f\n",a,b,c);
     for(i=0;i<3;i++){
     printf("TACalAliP: alignrow->delt[%i] %f\n",i,alignrow->delt[i]);
     
     printf("TACalAliP: trans[%i] %f\n",i,trans[i]);
     }
     for(i=0;i<3;i++){
     printf("TACalAliP: cog[%i] %f\n",i,cog[i]);
     }
     for(i=0;i<9;i++) {
        printf("TACalAliP: nederow->rot[%i] %f\n",i,nederow->rot[i]);
     };
     for(i=0;i<9;i++) {
        printf("TACalAliP: Grot[%i] %f\n",i,Grot[i]);
     };
     for(i=0;i<9;i++) {
        printf("TACalAliP: RA[%i] %f\n",i,RA[i]);
     };
*/     
}
