
// ********************************************************************
//
//  Routine:      acwrite_
//  Author:       T.Oest
//
//  Description:  interface routine for alignment/calibration
//                and data quality
//
//  Modification:
//   -- data quality added                            27/09/99 T.Oest
//   -- calibartion & alignment added                 19 Nov 1999 (AG)
//   -- AC_init() is moved to acinit                  22 Nov 1999 (AG)
//   -- use ARTE_mark()                               25 Apr 2000 (AG)
//
// ********************************************************************

// standard includes
#include <iostream.h>

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// prototypes
int DQ_evnt();
int AC_evnt();

//*********************************************************************
// function
//*********************************************************************
extern "C" void
acwrite_()
{
  // show up
  //cout << "acwrite_()" << endl;

  // inits
  int rc = 0;
  
  // call the data quality routine
  ARTE_mark( "DQ_evnt", 0 );
  rc = DQ_evnt();

  // alignment/calibration interface
  ARTE_mark( "AC_evnt", 0 );
  rc = AC_evnt();
}
