*-- Author :    Hartwig Albrecht   16/03/95

      SUBROUTINE DFFILE (LINK, TIO)

************************************************************************
*
* Description: handle input/output bits for tables
*   This Fortran routine is only a temporary solution and should be replaced
*   by the corresponding code in C, directly placed into dftabl.
*
* Called from: DFTABL
*
* External references: DFFILE1
*
* Argument in/out description
* TIO      in     'INPUT'  accept table on any input file
*                 '/INPUT' skip on input files
*                 The following names refer to symbolic file names:
*                 'DST'    DST output
*                 '/DST'   no output on DST
*                 'GEOM'   geometry output file
*                 '/GEOM'  no output on GEOM
*                 concatenate several options with blanks or commas,
*                 e.g. 'DST /INPUT,GEOM , /ABC'
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZMMCOM.fi"
#include "auto/MEMO.fi"

#ifdef _LINUX_
      INTEGER IOR
#endif

      INTEGER LINK, TIO(*), I, IB, IL, INOT
      CHARACTER CIO*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"

C parse CIO

      CALL CHTTOC (TIO, CIO)
      CALL CLTOU (CIO)
      I = 0

 10   INOT = 0
 20   CALL CHWORD (CIO, '/,', I, IB, IL)
      IF (IL .EQ. 0)  GO TO 40
      IF (CIO(IB:IL) .EQ. ',')  GO TO 10
      IF (CIO(IB:IL) .EQ. '/')  THEN
        INOT = 1
        I = IL
        GO TO 20
      END IF

      IF (CIO(IB:IL) .EQ. 'DST')  THEN
        CALL DFFILE1 (LINK, 'EV_IN', INOT)
        CALL DFFILE1 (LINK, 'EVIN1', INOT)
        CALL DFFILE1 (LINK, 'EVIN2', INOT)
        CALL DFFILE1 (LINK, 'EVIN3', INOT)
        CALL DFFILE1 (LINK, 'EVIN4', INOT)
        CALL DFFILE1 (LINK, 'DST_IN_NOTE', INOT)
        CALL DFFILE1 (LINK, 'DST_IN_EDIR', INOT)
        CALL DFFILE1 (LINK, 'DST_OUT', INOT)
      ELSE IF (CIO(IB:IL) .EQ. 'MINI')  THEN
        CALL DFFILE1 (LINK, 'EV_IN', INOT)
        CALL DFFILE1 (LINK, 'EVIN1', INOT)
        CALL DFFILE1 (LINK, 'EVIN2', INOT)
        CALL DFFILE1 (LINK, 'EVIN3', INOT)
        CALL DFFILE1 (LINK, 'EVIN4', INOT)
        CALL DFFILE1 (LINK, 'MINI_IN_NOTE', INOT)
        CALL DFFILE1 (LINK, 'MINI_IN_EDIR', INOT)
        CALL DFFILE1 (LINK, 'MINI_OUT', INOT)
      ELSE IF (CIO(IB:IL) .EQ. 'GEOM')  THEN
        CALL DFFILE1 (LINK, 'GEOMIN', INOT)
        CALL DFFILE1 (LINK, 'GEOMOUT', INOT)
        CALL DFFILE1 (LINK, 'GEODB', INOT)
      ELSE
        CALL DFFILE1 (LINK, CIO(IB:IL), INOT)
      END IF

      I = IL
      GO TO 10

 40   DO 50 I=1,NARLNK
 50   IQ(BQMEMO_IOA(I)) = BMEMO_IOD(I)

 60   IL = 0
      DO 70 I = 1, NARLNK
        IB = BMEMO_IOA(I)
        IF (IMEMO_SUP(1,I) .NE. 0)  
     +    IB = IAND (IB, BMEMO_IOA(IMEMO_SUP(1,I)))
        IF (IMEMO_SUP(2,I) .NE. 0)
     +    IB = IAND (IB, BMEMO_IOA(IMEMO_SUP(2,I)))
        IF (BMEMO_IOA(I) .NE. IB)  IL = 1
        IQ(BQMEMO_IOA(I)) = IB
 70   CONTINUE
      IF (IL .NE. 0)  GO TO 60

 90   END

************************************************************************
* End of DFFILE
************************************************************************
