*--   Author :    Serguei Moukhine

      SUBROUTINE MMDROP1 (JL, IL)

************************************************************************
*
* Description: drop one table JL
*
* Called from: MMDROP only
*
* External references: CMDROP
*
* Argument in/out description
*  JL      in     bank address
*  IL      in     bank index
*
************************************************************************

      IMPLICIT NONE

#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MEMO.fi"
#include "auto/MEMS.fi"

      INTEGER IL, JL(1), ND, NROWS, NCOLS, USED_ROWS, NMAX, NMAX1
      REAL E, SIGMA
      INTEGER CNST1, CNST2, CNST3, CNST4
      REAL RCNST1, RCNST2

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEMS.ff"

C if Zebra is used for memory management

      IF (CMINIT .EQ. 0) THEN
        IF (JL(1) .NE. 0)  THEN
           CALL MZDROP (IMEMO_DIV(IL), JL(1), ' ')
C===> commented by Essenov 25.08.1999:   CALL CMDROP (JL(1), ND)
           IQ(IQMEMO_DROP(IL)) = IQ(IQMEMO_DROP(IL)) + 1
C the next statement may be dangerous but cures one of the evils of Zebra
           JL(1) = 0
        END IF
        GO TO 99
      END IF


C if CM is used for memory management
C------------------------------------

C no actions for CM if bank is empty

      IF (JL(1) .EQ. 0)      GO TO 99
      IQ(JL(1)-2) = 1     ! Set DROP flag
      IF (N_U(JL(1)) .EQ. 0) GO TO 99

C calculate drop statistics

      IQ(IQMEMO_DROP(IL)) = IQ(IQMEMO_DROP(IL)) + 1

C drop table and get N of words in the bank (ND)

      NCOLS     = N_C(JL(1))
      USED_ROWS = N_U(JL(1))
      
      CALL CMDROP (JL(1), ND)

      IQ(JL(1)+1) = NCOLS ! Reset number of columns.
      IQ(JL(1)+2) = 0     ! Set number of rows to zero.

C call CMFREE if necessary

      NROWS = (ND-2)/NCOLS

      CNST1  = 2              ! n of booking
      CNST2  = 5002           ! n of words in the bank
      CNST3  = 500            ! n of rows in the bank (1-st time)
      CNST4  = 10             ! min n of rows in the bank
      RCNST1 = 4.             ! nmax  = Mean + RCNST1*Sigma
      RCNST2 = 1.3            ! nmax1 = RCNST2*nmax

      ! If not enough statistics then check n of words in the bank
      IF (IQ(IQMEMO_BOOK(IL)) .LE. CNST1)  THEN
        IF (ND .GT. CNST2 .AND. USED_ROWS .GT. CNST3)  THEN
          NROWS = CNST3
          ND = NCOLS * NROWS + 2
          CALL CMFREE (JL(1),ND)
        END IF
        
      ! If more or less enough statistics
      ELSE
        E = IQ(IQMEMO_ACCROW(IL))
        E = E / IQ(IQMEMO_BOOK(IL))
        SIGMA = Q(QMEMO_MOM2(IL))
        SIGMA = SQRT(SIGMA)
        NMAX = E + RCNST1*SIGMA + 0.5
        NMAX1 = RCNST2*NMAX
        IF (NROWS .GT. NMAX1 .AND. NROWS .GT. CNST4 + 1)  THEN
          NROWS = NMAX
          ND = NCOLS * NROWS + 2
          CALL CMFREE (JL(1),ND)
          IQ(IQMEMO_EXT(IL)) = MAX (NMAX1 - NMAX, CNST4)
        END IF
      END IF

   99 END

************************************************************************
* End of MMDROP1
************************************************************************
