*CMZ :  3.01/00 29/08/96  19.06.38  by  Siegmund Nowak
*CMZ :          29/08/96  19.05.34  by  Siegmund Nowak
      SUBROUTINE IRQLC(IWKIDI,LCN,ISTATI,ITNRI,XLOC,YLOC)
*.===========>
*.
*.   This routine returns the graphic cursor position in WC space in
*. XLOC and YLOC. The same position in the NDC space is available in
*. RQUEST(11) and RQUEST(12). The normalization tranformation number
*. is returned in TNR. After a call to IRQLC the window coordinates
*. are available in RQUEST(20), RQUEST(21), RQUEST(22), and RQUEST(23).
*. The viewport coordinates are available in RQUEST(30), RQUEST(31),
*. RQUEST(32), and  RQUEST(33). This routine computed the XLOC and YLOC
*. value according to value of the REDIT factor, but the value of
*. RQUEST(11) and RQUEST(12) do not care about the value of REDIT. The
*. REDIT factor is usefull for the graphics editor and the menu mode of
*. KUIP.
*.   The values of XLOC and YLOC are computed with the parameters stored
*. in the NT storage (HINT) if ZEBRA is not used, or if there no
*. displayed picture. If an HIGZ picture is displayed, only the NT
*. existing in this picture are used to compute the values of XLOC and
*. YLOC.
*.   This routine can work in two modes :
*.    - The REQUEST mode where a "Button_Press" event is necesary to get
*.      the cursor position.
*.    - The SAMPLE mode where only a move of the mouse is enough to get
*.      the cursor position.
*.
*. _Input parameters:
*.
*.  INTEGER IWKIDI : Workstation identifier .
*.  INTEGER LCN    : Input device number .
*.                   If LCN>10 then LCN=10*IPET+LNDNR
*.
*.                 LCN=10 tracking cross
*.                 LCN=20 cross-hair
*.                 LCN=30 rubber circle
*.                 LCN=40 rubber band
*.                 LCN=50 rubber rectangle
*.                 LCN=99 the screen coordinates are taken
*.                        in XLOC and YLOC (X11 only).
*.
*.                 LCN>0  request mode
*.                 LCN<0  sample mode
*.
*. _Output parameters:
*.
*.  INTEGER ISTATI : Return status: 0=BREAK, 1=OK .
*.  INTEGER ITNRI  : Normalization transformation number .
*.  REAL XLOC YLOC : Cursor position in WC space .
*.
*..==========> (O.Couet)

      PARAMETER (IBUFSI=1000)
      COMMON /HIKERN/ WKSC(10),ICURWK,WINSIZ(4)
     +,IPOS(2,IBUFSI),LUNWIN,THX11,IFPX11,RMAGN
      INTEGER WINSIZ
      INTEGER*2 IPOS
      COMMON /HIKERC/ CHHOST,FILEN,FX11
      CHARACTER*80 CHHOST,FILEN,FX11

      COMMON /QUEST/ IQUEST(100)
      DIMENSION RQUEST(100)
      EQUIVALENCE (IQUEST(1),RQUEST(1))

      COMMON /HILOC/ OLDXP,OLDYP

      INTEGER INTR,IWTYPE,IDID,IDTY,ILOPWK(10),IWTYL(10),INOPWK
     +,       IWINID(10),IPICT,ICLIP,NT0PRI,IPLCI,ILN,IPMCI,IMK,IFACI
     +,       IFAIS,IFASI,ITXCI,ITXALG,IFTPR,INPASS,IBORD,INLINE
     +,       INTATT(17),IFONT,IPREC,ITXALH,ITXALV,IDIM,INBCOL,IZBUF
      REAL XRATIO,YRATIO,RWXMIN,RWXMAX,RWYMIN,RWYMAX,RVXMIN,RVXMAX
     +,    RVYMIN,RVYMAX,RDWXMI,RDWXMA,RDWYMI,RDWYMA,RDVXMI,RDVXMA
     +,    RDVYMI,RDVYMA,RMDSX,RMDSY,XWKSIZ(10),YWKSIZ(10),WKMAX(10)
     +,    XWKR(10),YWKR(10),XWKW1(10),YWKW1(10),XWKV1(10),YWKV1(10)
     +,    XWKW2(10),YWKW2(10),XWKV2(10),YWKV2(10),REDIT,RMKSC,RLWSC
     +,    RBSL,RANGLE,RCHH,RCSHIF,RBOF,RBWD,RAWL,RTMS,RALH,RALD
     +,    REAATT(18),RCHUX,RCHUY
       LOGICAL ACWKFL(10),NODRFL(10)
      COMMON /HIATT/ INTR,XRATIO,YRATIO
     +,RWXMIN,RWXMAX,RWYMIN,RWYMAX,RVXMIN,RVXMAX,RVYMIN,RVYMAX
     +,RDWXMI,RDWXMA,RDWYMI,RDWYMA,RDVXMI,RDVXMA,RDVYMI,RDVYMA
     +,RMDSX ,RMDSY ,IWTYPE,IDID  ,IDTY
     +,ILOPWK,ACWKFL,NODRFL,IWTYL ,INOPWK
     +,XWKSIZ,YWKSIZ,WKMAX ,IWINID,XWKR  ,YWKR
     +,XWKW1 ,YWKW1 ,XWKV1 ,YWKV1
     +,XWKW2 ,YWKW2 ,XWKV2 ,YWKV2
     +,IPICT ,ICLIP ,REDIT,NT0PRI
     +,RMKSC ,RLWSC ,RBSL  ,RANGLE,RCHH  ,RCSHIF,RBOF  ,RBWD
     +,RAWL  ,RTMS  ,RALH  ,RALD  ,REAATT
     +,IPLCI ,ILN   ,IPMCI ,IMK   ,IFACI ,IFAIS ,IFASI ,ITXCI
     +,ITXALG,IFTPR ,INPASS,IBORD ,INLINE,INTATT
     +,IFONT ,IPREC ,ITXALH,ITXALV,RCHUX ,RCHUY
     +,IDIM  ,INBCOL,IZBUF

      LOGICAL SAMPLE

*.______________________________________
*
      IWKIND    = IGIWIN(IWKIDI)
      IQUEST(1) = 0
      IF(IWKIND.EQ.0)THEN
         CALL IGERR('Workstation is not open','IRQLC')
         RETURN
      ENDIF
      IF(IWTYL(IWKIND).LE.0)THEN
* No locator for Metafile.
         CALL IGERR('No request locator on metafile','IRQLC')
         RETURN
      ENDIF
*
      IF (LCN.GE.0) THEN
         SAMPLE = .FALSE.
      ELSE
         SAMPLE = .TRUE.
      ENDIF
      IPET = 1
      IF(ABS(LCN).GE.10)THEN
         IPET = ABS(LCN)/10
      ENDIF
*
      IF(LCN.EQ.99)THEN
         IIX=INT(XLOC)
         IIY=INT(YLOC)
         ISTATI=99
         GOTO 80
      ENDIF
      CALL IXSELWI(IWINID(IWKIND))
      IF(SAMPLE)THEN
         ISTATI=IXREQLO(1,IPET,IIX,IIY)
      ELSE
         ISTATI=IXREQLO(0,IPET,IIX,IIY)
      ENDIF
      IF(ISTATI.EQ.3)ISTATI=0
   80 RQUEST(11)=FLOAT(IIX)/WKMAX(IWKIND)
      RQUEST(12)=(YWKSIZ(IWKIND)-FLOAT(IIY))/WKMAX(IWKIND)
*
   90 IF(ISTATI.EQ.0.AND..NOT.SAMPLE)THEN
         RQUEST(11)=OLDXP
         RQUEST(12)=OLDYP
         RETURN
      ENDIF
      OLDXP=RQUEST(11)
      OLDYP=RQUEST(12)
      SCALE=1.
      IF(REDIT.NE.0.)SCALE=REDIT
      RQUEST(20)=0.
      RQUEST(21)=1.
      RQUEST(22)=0.
      RQUEST(23)=1.
      RQUEST(30)=0.
      RQUEST(31)=1.
      RQUEST(32)=0.
      RQUEST(33)=1.
      ITNRI=0
      XLOC=(RQUEST(11)+RDWXMI*REDIT)/SCALE
      YLOC=(RQUEST(12)+RDWYMI*REDIT)/SCALE
*
      IPRIOO = NT0PRI
      IEND   = IGNNXT(1)
  120 IF(IEND.EQ.0)THEN
         CALL IGNGET(NNT,IPRION,IHPRIO
     +,              RQUEST(20),RQUEST(21),RQUEST(22),RQUEST(23)
     +,              RQUEST(30),RQUEST(31),RQUEST(32),RQUEST(33),I3D)
*
      XR = (RQUEST(31)-RQUEST(30))/(RQUEST(21)-RQUEST(20))
      XD = FLOAT(IIX)
      XV = (XD-XWKV1(IWKIND))/XWKR(IWKIND)+XWKW1(IWKIND)
      XW = (XV-RQUEST(30))/XR+RQUEST(20)
*
      YR = (RQUEST(33)-RQUEST(32))/(RQUEST(23)-RQUEST(22))
      YD = YWKSIZ(IWKIND)-FLOAT(IIY)
      YV = (YD-YWKV1(IWKIND))/YWKR(IWKIND)+YWKW1(IWKIND)
      YW = (YV-RQUEST(32))/YR+RQUEST(22)
*
         IF(XV.LE.RQUEST(31).AND.XV.GE.RQUEST(30).AND.
     +      YV.LE.RQUEST(33).AND.YV.GE.RQUEST(32))THEN
            IF(IPRION.GT.IPRIOO)THEN
               XLOC=XW
               YLOC=YW
               ITNRI=NNT
               IPRIOO=IPRION
            ENDIF
         ENDIF
         IEND = IGNNXT(0)
         GOTO 120
      ENDIF
*
      END



