#include "arte/arte.hh"
#include "care/caredata.hh"
#include "care/ECALtypes.hh"

#include <math.h>

      // 
      //  Energy cluster threshold 
      //  for 1) low energy recovery
      //      2) main cluster selection
      //
      // Set now to a ROUGHLY pt threshold (lower than a PT) for ONLINE
      // and to a constant threshold for offline


Energy_t ecCutFunction(ArtePointer<ECHS> echs){

#ifndef ONLINE
  return ECalInfo.clusThr;
#else
  return ECalInfo.clusThr *
    sqrt(echs->r*echs->r+ECalInfo.ecalp->z1*ECalInfo.ecalp->z1) /
    (echs->r+0.1);
#endif

}


