//                              -*- Mode: C++ -*-
//: CmdCareLevel.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCARELEVEL_HH_
#define CMDCARELEVEL_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"

/**
class  CmdCareLevel
  Class to deal with the care/level kuip command
*/

class CmdCareLevel : public CmdBase {
public:
  /// Constructor
  CmdCareLevel();
  /// Destructor
  virtual ~CmdCareLevel();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();

# ifdef USEKUIP
  //--
  ///   Read a command from external
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();
  //
  /// Return the trigger level in use
  static unsigned int level() { return triglevel;};
  /// Return the maximum number of cells to clusterize
  static  unsigned int ncells() { return numOfCells;};

  /// Set internal data
  static void setLevel(unsigned int level, unsigned int numcells);

private:
 
  //--
  static unsigned int triglevel;
  static unsigned int numOfCells;
};

#endif  //   CMDCARELEVEL_HH_
