 
// *****************************************************************************
//
// source:    DQ_RECO_rec_init.C
//
// type:      source code
//
// created:    5 Jul 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_init()
//
// changes:
//  5 Jul 2000 (AG) creation
//  7 Jul 2000 (AGO polished printout
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RECO.h"

//
// function code
//
int
DQ_RECO_rec_init()
{
  // show up
  ARTE_mark( "DQ_RECO_rec_init 0", 0 );
  cout << "DQ_RECO_rec_init" << endl;
  
  // error flag
  rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 1 ), 
	      "RECO error flag ", 34, -0.5, 33.5 );

  // DQ inits
  DQ_RECO_vertex_init();
  DQ_RECO_JPSIEE_init();
  DQ_RECO_JPSIMM_init();
  DQ_RECO_CAL1HT_init();

  // show up 
  ARTE_mark( "DQ_RECO_rec_init 1", 0 );

  return 0; // return error code (0 = okay)
}
