
// ******************************************************************
//
// M. Braeuer / D. Samtleben
//
// Filling of histograms
//
// changes:
// 22 Oct 1999 (AG)  polsih SVD stuuf
// 28 Oct 1999 (AG)  use defines from DQ.h
//  1 Nov 1999 (AG)  get rid of dq_hid.h
// 10 Dez 1999 (MBr) major update
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>
#include "math.h"

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

// from Alignment stuff:
inline int fUnsin(int sl,int sec,int lay) { 
  int i = (lay-1)+(4*(sec-1))+(16*(sl-1));
  return(i); 
}

//
// function code
//
int
DQ_SVD_hit_evnt()
{
  float NrSVDHits=0,VDSusid,VDSocc;
  int unusedhits=0; 

//====================================================================
//     loop over HITB to fill histograms 
//====================================================================
 
  for( ArteTableIterator<HITB> hitb; hitb.valid(); hitb.next() ){
    
    ArtePointer<GEDE> gede(hitb->gede); 
    if(gede->cmp==1) {
      if(hitb->rseg.begin()==hitb->rseg.end() ) {
	unusedhits++;
      }
      NrSVDHits++;
      VDSusid = float(fUnsin(gede->gesl->nsl,gede->sec,gede->lay) ); 
      
      // hit/plane raw:
      rhp_hf1(DQ_ID(COMP_SVD,LVL_HIT,100),VDSusid,1);
      
      // occupancy: (go back to real strips on plane)
      VDSocc = (hitb->x - gede->xfw[0]) / gede->pit;
      rhp_hfill(DQ_ID(COMP_SVD,LVL_HIT,102),VDSusid,VDSocc,1);
      
    }
  }
  //====================================================================
  //       histogram of Hit multiplicities
  //====================================================================
  rhp_hf1(DQ_ID(COMP_SVD,LVL_HIT,101),NrSVDHits,1);
  rhp_hf1(DQ_ID(COMP_SVD,LVL_HIT,301),unusedhits,1);
   
  return 0; // return error code (0 = okay)
}
