//  routine ItrEvnt 
//  last change 15/11/99 Torsten Zeuner

#ifndef _NOARTE_

#include <stdio.h>
#include <iostream.h>
#include <strings.h>
#include <stdlib.h>

// some Arte stuff
#include "arte/arte.hh"
#include "farm/farm.hh"

// prototype declarations
#include "ITR_EVinfo.h"
#include "aframelib.h"
#include "ITR_arte.h"
#include "itrleda.h"
#include "ITR_silraw.h"
#include "ITR_marvin.h"

// return codes
#include "grr.h"

// sparse event definition
#include "event.h"
#include "esp.h"


// size and location of sparsified event

#define ITRNBUFF        500000 
char ITR_sparsevt[ITRNBUFF];
ITR_Marvin_Sevt_t *sevt;

//-----------------------------------------------------------------------------

int ItrEvnt()
{
    
  char *routine = "ItrEvnt";

  // for the first event initialize ITR

  int rc;
  static bool ITR_firsttime = true;
  if (ITR_firsttime) {
    rc = ItrRunStart();
    ITR_firsttime = false;
    if (rc!=GRR_OK) {
      aframe_mess(routine,GRR_SERROR,"ITR initialization failed !"); 
      return GRR_FISHY;
    }
  }

  // REAL DATA
  //
  // Now the actual event routines
  //
  // fill ITR_SILRAW structure and call ITR_marvin in case of raw data format

  // get event pointer

  EVENT_HDR *event = ARTE_get_event();

  if ( !event ) {
    aframe_mess(routine,GRR_SERROR,"Could not find event!");
    return GRR_FISHY;
  }      

  rc = ITR_silraw_event( (char*) event, 0 );
  if ( rc != GRR_OK ) return GRR_FISHY;
  

  // Do cluster finding

  sevt = ITR_marvin_fetch_sevt();

  if ( !sevt ) {
    printf("no ITR_Marvin_Sevt_t available (ITR_marvin not initialized?)");
    aframe_mess(routine,GRR_SERROR,"no ITR_Marvin_Sevt_t available (ITR_marvin not initialized?)");
    return GRR_FISHY;
  }

  sevt->data = ITR_sparsevt; 
  sevt->size = ITRNBUFF;    // negative: reallocation allowed!
  sevt->next = sevt->data; 

  ITR_marvin_event();  
 
  // Fill HITB table

  rc = ITR_fillHITBfromSPARSEVT();

  if ( rc != GRR_OK ) {
    aframe_mess(routine,GRR_SERROR,"Could not fill HITB table correctly.");
  }

  return GRR_OK;

}

#endif   /* of #ifndef _NOARTE_ */
