*CMZ :  1.01/02 05/02/96  21.47.33  by  Fedor Ratnikov
*CMZ :  1.00/00 13/12/94  20.51.13  by  Dominik Ressing
*CMZ :  0.01/02 22/08/94  12.18.25  by  Dominik Ressing
*CMZ :  0.01/01 25/07/94  15.23.37  by  Dominik Ressing
*-- Author :    Dominik Ressing   18/07/94
************************************************************************************
*
* L1MESIN
* written by Dominik Ressing, 20/07/94 19.16.12
*
* This routines action:
* Initializes the message chains by building up a chain of messages down from
* the free header.
*
*       !!!! Prior to this routine L1DEFPC has to be called !!!!!!
*
************************************************************************************
c
      SUBROUTINE l1mesin
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
c
      INTEGER imespo,imesold,iBX
#include "l1si/l1mesdf.ff"
c
c     --- ``constant'' from L1MESDF
      L1MElen = L1MEhead+L1MEroi(L1PARnsup+1)  ! length of message information
c
c     --- no messages used so far
      L1MEstor(L1MEused+L1MEnext) = 0
      L1MEstor(L1MEused+L1MEprev) = 0
c     --- this is the first free storage since we do not need the
c         message data in the 2 top-entries
      L1MEstor(L1MEfree+L1MEnext) = L1MEused+L1MEhead
      L1MEstor(L1MEfree+L1MEprev) = 0
c
c     --- current and next message pointers !!
      imesold = L1MEfree
      imespo  = L1MEstor(imesold+L1MEnext)
c     --- build up chain:
      DO WHILE(imespo.lt.L1MEmast-L1MElen+1)
c        --- pointer to previous stored message
         L1MEstor(imespo+L1MEprev) = imesold
c        --- increment pointer to ``last stored message''
         imesold = imespo
c        --- increment ``message-pointer'' by actual length of message
         imespo  = imespo + L1MElen
c        --- store pointer to next message
         L1MEstor(imesold+L1MEnext) = imespo
c
      ENDDO
c     --- store 0 in pointer to next message for last message in chain
      L1MEstor(imesold+L1MEnext) = 0
c
c     --- no BX traces jet:
      DO iBX=1,L1MAXbxes
         L1MEbx(L1MEBXn   ,iBx) = 0  ! no messages for bunch crossing iBX
         L1MEbx(L1MEBXfipo,iBx) = 0  ! no pointer as well
         L1MEbx(L1MEBXnact,iBx) = 0  ! no active messages
      END DO
c
      RETURN
      END
