
// *****************************************************************************
//
// source:    l4t.C
//
// type:      source code
//
// created:   21 Feb 2000
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY-IfH Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// changes:
// 21 Feb 2000 (AG) creation
//
// *****************************************************************************

// standard includes
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

// ONLINE includes

// ARTE includes
#include "l4trig/l4t.hh"

// prototypes
extern "C" void kugetc_( char *string, int *len, int len1 );

// globals
int FATRG = 0;

//
// program code
//
extern "C"
void
l4_comp_()
{
  //cout << "l4_comp_()" << endl;

  // read in status
  int len  = 0;
  int len1 = 3;
  char input[7];
  kugetc_( input, &len, len1 );
  input[len] = 0;
  char *status  = (char *) malloc( len + 1 );
  strncpy( status, input, len );
  status[len] = '\0';
  //cout << "l4_comp_(): status=" << status << endl;
  
  // convert to upper case letters
  if( len>0 ){
    for( int i=0; i<len; i++ ){
      status[i] = toupper( status[i] );
    }
  }
  
  // check
  if( strncmp( status, "ON",  2 ) &&
      strncmp( status, "OFF", 3 ) &&
      strncmp( status, "KEE", 3 ) &&
      strncmp( status, "REJ", 3 )    ){
    cout << "l4_comp_(): ********* L4/TRIG: unknown status="
	 << status << endl;
  }
  else {
    //cout << "l4_comp_(): " << status << endl;
  }

  // set flag
  if (!strncmp( status, "ON",  2 ) ) FATRG = L4_ON;
  if (!strncmp( status, "KEE", 3 ) ) FATRG = L4_KEEP;
  if (!strncmp( status, "REJ", 3 ) ) FATRG = L4_REJECT;
 
  // print
  cout << "L4/TRIG: " << FATRG << endl;
}
