
// Boris Fominykh 14.02.2000
// fill the muon data base

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>

#include "murec/MuDbNede.h"
#include "murec/MuDbNesl.h"
#include "murec/MuDbAlign.h"
#include "murec/MuDbConfig.h"
#include "murec/MuDbHots.h"

extern "C" {
  int MuDbGeoWrite(int, char*);
  int MuDbGeoPrint(int, char*);
  void kugeti_();
void mudbfill_()
{
// set the indicators
  int geo   = 0;
  int align = 0;
  if(getenv("MUON_ALIGN") != NULL) align = 1;
  int cabl  = 0;
  if(getenv("MUON_CONFIG") != NULL) cabl = 1;
  int hot   = 0;
  if(getenv("MUON_BADFILE") != NULL) hot = 1;
  int run=0;
  kugeti_(&run);
  if(run <= 0) {
    cout << "MuDbFill: wrong run= " << run << endl;
    return;
  }

// print flag
  int print = 0;

  cout << "MuDbFill: GeoFlag= "  << geo;
  cout << " AlignFlag= " << align;
  cout << " CablFlag= " << cabl;
  cout << " HotListFlag= " << hot;
  cout << " PrintFlag= " << print;
  cout << endl;

// set the sources
  char* DBname    = "/MUON_DB";
  char* AlignFile = getenv("MUON_ALIGN");
  char* CablFile  = getenv("MUON_CONFIG");
  char* HotFile   = getenv("MUON_BADFILE");
  int ret=0;

  cout << "MuDbFill: DBname " << DBname << " run= " << run << " print " << print << endl;
  if(align == 1) cout << " AlignFile " << AlignFile << endl;
  if(cabl == 1)  cout << " CablFile " << CablFile << endl;
  if(hot == 1)   cout << " HotFile " << HotFile << endl;

// add the geometry tables
  if(geo == 1) {
    int ret=MuDbGeoWrite(run,DBname);
    cout << "MuDbFill: geometry is in DB, ret= " << ret << endl;
  }
  if(geo == 1 && print == 1) ret=MuDbGeoPrint(run,DBname);

// add the allignment table
  if(align == 1) {
    MuDbAlign Align;
    Align.setDBname(DBname);
    Align.setFile(AlignFile);
    Align.setKTstatus(-3);
    Align.setRun(run);
    Align.setMinor(0);
    ret=Align.Create();
    cout << "MuDbFill: alignment is in DB, ret= " << ret << endl;
    if(print == 1) Align.Print();
  }

// add the cabling table
  if(cabl == 1) {
    MuDbConfig Conf;
    Conf.setDBname(DBname);
    Conf.setKTstatus(-3);
    Conf.setRun(run);
    Conf.setMinor(0);
    Conf.setFile(CablFile);
    ret=Conf.Create();
    cout << "MuDbFill: cabling is in DB, ret= " << ret << endl;
    if(print == 1) {
      int NcabR=0;
      Conf.Read(&NcabR);
      Conf.Print();
      Conf.Release();
    }
  }

// add the list of hot channels
  if(hot == 1) {
    MuDbHots Hots;
    Hots.setDBname(DBname);
    Hots.setKTstatus(-3);
    Hots.setRun(run);
    Hots.setMinor(0);
    Hots.setFile(HotFile);
    ret=Hots.Create();
    cout << "MuDbFill: list of hot channels is in DB, ret= " << ret << endl;
    if(print == 1) {
      Hots.Read();
      Hots.Print();
      Hots.Release();
    }
  }

  return;
}
}


