*
* B.Fominykh  28.07.97
*
* kalman filter fit for muon segment
      SUBROUTINE MUIFIT(NHT,IHT,CHI,IOUT)
*     ===================================
* input:  NHT  - number of hits
*         IHT(NHT) - list of hits ordered on Z
* output: CHI  - chi**2
*         IOUT =0 - O.K.
*
      IMPLICIT NONE
*
      INTEGER NHT,IHT(1),IOUT,IH,JH
      INTEGER ITP,I,J,IHH
      REAL ERMSC1,ERMSC2,CHI1,CHI2,CHI
      REAL Z,Z1,Z2,THETS,SIGE,DD,DD1,DD2
      DOUBLE PRECISION ZE,XE,YE,SX,SY,HX(4),HY(4)
      DOUBLE PRECISION PAR0(6),COV0(4,4)
#include "murec/MUCKALF.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCPAR.fi"
#include "murec/MUCTAB.fi"
#include "arte/Arte.fi"

#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
      IF(NHT.LE.0) GOTO 900
* zero iteration
      CALL MURFIT0(NHT,IHT,PAR0,COV0,IOUT)
      IF(IOUT.NE.0) GOTO 900
      IOUT=1
      DO I=1,5
        PARAM(I)=PAR0(I)
      ENDDO
      DO I=1,4
       DO J=1,4
        COV(I,J)=COV0(I,J)
       ENDDO
      ENDDO
*
      IF(IPRSC.GE.4) PRINT 1005, (PARAM(J),J=1,5),
     +                       ((COV(I,J),I=1,4),J=1,4)
      IF(IPRLG.GE.4) WRITE(LLOGF,1005) (PARAM(J),J=1,5),
     +                       ((COV(I,J),I=1,4),J=1,4)
 1005 FORMAT(1X,'initial Z0,Cx,Cy,Tx,Ty:',5E11.3,
     +         ' cov:',4(/,10X,4E12.4))
*
* kalman filter fit - loops over hits
      Z2=2150.
      DO 100 IHH=NHT,1,-1
        IH=IHT(IHH)
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        Z=Q(JH+6)
* calculate multiple scattering error
        Z1=Z2
        Z2=Z
        CALL MURMSC(Z1,Z2,ERMSC1,ERMSC2,THETS)
*
        ITP=IQ(JH+5)
* the case of wire
        IF(ITP.EQ.1) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JH+6)
          SINROT =Q(JH+7)
          COSROT =SQRT(1.-SINROT*SINROT)
          DMEAS=Q(JH+8)
          SMEAS=Q(JH+11)
          ITMEAS=1
          IF(SINROT.NE.0.) ITMEAS=3
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD,SIGE,CHI1)
          IF(IOUT.NE.0) GOTO 900
          CHI=CHI+CHI1
          GOTO 100
        ENDIF
*
* the case of pads and pixels
        IF(ITP.EQ.2.OR.ITP.EQ.3) THEN
* fill COMMON/MUCKALF/
          SIGMS1=ERMSC1
          SIGMS2=ERMSC2
          THTMSC=THETS
          ZMEAS=Q(JH+6)
          SINROT =0.
          COSROT =1.
          DMEAS=Q(JH+8)
          SMEAS=Q(JH+11)
          ITMEAS=1
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD1,SIGE,CHI1)
          IF(IOUT.NE.0) GOTO 900
*
          DMEAS=Q(JH+9)
          SMEAS=Q(JH+12)
          ITMEAS=2
* one step of kalman fit
          CALL MURKALF(2,IOUT,DD2,SIGE,CHI2)
          IF(IOUT.NE.0) GOTO 900
          CHI=CHI+CHI1+CHI2
          GOTO 100
        ENDIF
 100  CONTINUE
*
      IF(IPRSC.GE.4) PRINT 1006, (PARAM(J),J=1,5),
     +                       ((COV(I,J),I=1,4),J=1,4)
      IF(IPRLG.GE.4) WRITE(LLOGF,1006) (PARAM(J),J=1,5),
     +                       ((COV(I,J),I=1,4),J=1,4)
 1006 FORMAT(1X,'not transp. Z0,Cx,Cy,Tx,Ty:',5E11.3,
     +         ' cov:',4(/,10X,4E12.4))
*
* control extrapolation to ZE
        ZE=ZOTEXT
        XE=PARAM(4)*(ZE-PARAM(1))+PARAM(2)
        YE=PARAM(5)*(ZE-PARAM(1))+PARAM(3)

* projection matrix
        HX(1)=1.
        HX(2)=0.
        HX(3)=ZE-PARAM(1)
        HX(4)=0.

        HY(1)=0.
        HY(2)=1.
        HY(3)=0.
        HY(4)=ZE-PARAM(1)
* error of extrapolation
      SX=0.
      DO I=1,4
      DO J=1,4
        SX=SX+HX(I)*COV(I,J)*HX(J)
      ENDDO
      ENDDO

      SY=0.
      DO I=1,4
      DO J=1,4
        SY=SY+HY(I)*COV(I,J)*HY(J)
      ENDDO
      ENDDO
*

      IF(IPRSC.GE.4)
     + PRINT 1017, ZE,XE,SQRT(SX),YE,SQRT(SY)
      IF(IPRLG.GE.4)
     + WRITE(LLOGF,1017) ZE,XE,SQRT(SX),YE,SQRT(SY)
 1017 FORMAT(5X,'extr to z=',F7.1,' XE,SX:',2F8.3,' YE,SY:',2F8.3)
*
 900  CONTINUE
      RETURN
      END









