*-- Author :    Rainer Mankel   02/11/93

      subroutine dipro(dc,xxx,yyy)

*     **** projects 3dim detector frame coordinates into
*     **** the world coordinates xxx and yyy
      implicit none
#include "pris/zgraf.fi"

      real dc(3), dcs(3), xxx, yyy
      real cp, sp, ct, st, radeg, yhyp
      integer ii
      data radeg /57.29578/

      if (iviewzg.eq.0) then
*        **** xy view
         xxx = dc(1)
         yyy = dc(2)
      elseif (iviewzg.eq.1) then
*        **** xz view
         xxx = dc(3)
         yyy = dc(1)
      elseif (iviewzg.eq.2) then
*        **** yz view
         xxx = dc(3)
         yyy = dc(2)
      elseif (iviewzg.ge.3.and.iviewzg.le.6) then
         if (iviewzg.eq.3) then
*           **** spatial view
            ct = cos(thetzg / radeg)
            st = sin(thetzg / radeg)
            cp = cos(phizg / radeg)
            sp = sin(phizg / radeg)
       elseif (iviewzg.eq.4) then
*         **** isometric view
          ct = sqrt(2./3.)
          st = sqrt(1./3.)
          cp = sqrt(0.5)
          sp = cp
       elseif (iviewzg.eq.5) then
*         **** dimetric view
          ct = sqrt(0.8)
          st = sqrt(0.2)
          cp = sqrt(0.75)
          sp = 0.5

       elseif (iviewzg.eq.6) then
*         **** trimetric view
          ct = sqrt(5./6.)
          st = sqrt(1./6.)
          cp = sqrt(0.7)
          sp = sqrt(0.3)
       endif

*      **** scale factors
       do 10 ii=1,3
 10    dcs(ii) = dc(ii) * fscalzg(ii)

       xxx =   cp * dcs(1)                    - sp * dcs(3)
       yyy = - st * sp * dcs(1) + ct * dcs(2) - st * cp * dcs(3)

      elseif (iviewzg.eq.7) then
*        **** x-stereo view (u)
         xxx = dc(3)
         yyy = ucoszg * dc(1) - usinzg * dc(2)
      elseif (iviewzg.eq.8) then
*        **** x-stereo view (v)
         xxx = dc(3)
         yyy = ucoszg * dc(1) + usinzg * dc(2)
      elseif (iviewzg.eq.9) then
*        **** cone-correction view
         xxx = dc(3)
         yyy = dc(1) * (1000.+10.) / (dc(3)+10.)
      elseif (iviewzg.eq.10) then
*        **** cone-correction view with hyperbolic blowup
         xxx = dc(3)
         yyy = dc(1) * (1000.+1.) / (dc(3)+1.)
*        **** log scale corr
         yhyp = abs(yyy)
         if (yhyp.gt.10.) then
            yyy = 100. * sign(alog(yhyp/10.)+1.,yyy)
         else
            yyy = 100. * yyy/10.
         endif
      elseif (iviewzg.eq.11) then
*        **** dipro should not be called for cone view
         xxx=20.
         yyy=20.
      else
         print *,' () dipro: invalid view, iviewzg=',iviewzg
      endif

      end










