*-- Author :    Rainer Mankel      03/01/96
*-- updated:    Alexander Lanyov   01/07/00 - addition of RSEG, info in GEDE

      subroutine pkpick()

*     **** (re)pick the picture, using parameters stored in
*     **** /zgrafr/ and /zgrafc/
*     **** may be called by kuip!
      implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"
      character*40 chopt
      character*10 cpick
      character*15 cname
      character*40 corigin, cdestiny
      character*50 s
      character*12 hwc
      integer islsta, islend, isl, idmc, pl, ipl, ipl_i, nch, mimp,
     +        layer, sector, mv, rv, cmp, iwl, mc, hit, jauxpl, tuhrtra,
     +        rc, rs, c, i
      integer ndetmx
      parameter (ndetmx=9000)
      integer ipldis(ndetmx), indexz(ndetmx), npldis, idrc, idrs, iipl,
     +     istat, nt
      real zpldis(ndetmx), wcm(3), xxx(1), yyy(1), x, y, savecol, pmc,
     +     alpha, arot, prc, prsf, prse

      logical pickmc, pickrc, pickmimp, pickhit, pickpl, pickmv, pickrv,
     +     pickwall, pickrs
      integer lenocc
      external dimag

#include "auto/GEO.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/RTRA.fi"
#include "auto/RSEG.fi"
#include "auto/HITB.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/RSEG.ff"
#include "auto/RTRA.ff"
#include "auto/HITB.ff"

      if (prisinit.eq.0) then
         print *,' () pkpick: display not initialized!'
         go to 999
      endif

      call kugetc(cpick,nch)    ! get object to be picked

      pickmc = index(cpick,'MC').eq.1.or.index(cpick,'MTRA').eq.1
      pickrc = index(cpick,'RC').eq.1.or.index(cpick,'RTRA').eq.1
      pickrs = index(cpick,'RS').eq.1.or.index(cpick,'RSEG').eq.1
      pickmimp = index(cpick,'MI').eq.1
      pickhit = index(cpick,'H').eq.1
      pickpl = index(cpick,'P').eq.1.or.index(cpick,'GEDE').eq.1
      pickmv = index(cpick,'MV').eq.1
      pickrv = index(cpick,'RV').eq.1
      pickwall = index(cpick,'WA').eq.1

      if (.not.(pickmc.or.pickrc.or.pickmimp.or.pickhit.or.pickpl
     +     .or.pickmv.or.pickrv.or.pickwall.or.pickrs)) then
         print *,' () pkpick: invalid PICK mode,  ',cpick
         go to 999
      endif

*     **** request pick locator
*     **** pick graphical objects in current display

      call irqlc(1,1,istat,nt,x,y)

      if (istat.ne.1) then
         print *,' () pkpick: locator input failed'
         go to 999
      endif
      xxx(1) = x
      yyy(1) = y
      call ismk(30)
      call ismksc(1.)
      call ipm(1,xxx,yyy)

      xpickzg = x
      ypickzg = y
      idpickzg = 0
      rpickzg = 1.e20

*     **** get redraw parameters from /zgrafr/, /zgrafc/
      if (modezg.eq.2) then
         islsta = sl1zg
         islend = sl2zg
      else
         islsta = 1
         islend = iq(jgesl+2)
      endif
      pl = plzg
      idmc = mczg
      idrc = rczg
      mv = mvzg
      rv = rvzg
      layer = layerzg
      sector = sectorzg
      cmp = cmpzg
      chopt = choptzg

*     **** fixup
      if (islend.eq.0.and.islsta.ne.0) islend = islsta
      islsta = max(islsta,1)
      if (islend.eq.0) then
       islend = iq(jgesl+2)
      endif

      call tusomh()

      npldis = 0

      if (modezg.eq.1.or.modezg.eq.2) then
*        **** display superlayer range
         do 10 isl=islsta,islend
            if (modezg.eq.1) then
               if (isl.gt.scmxzg) go to 10
               if (.not.lscopzg(isl)) go to 10
            endif

            if (igesl_cmp(isl).le.4.or.igesl_cmp(isl).eq.6
     +           .or.igesl_cmp(isl).eq.8.or.igesl_cmp(isl).eq.9) then ! tracking su

*              **** loop over planes
               do 20 iipl=1,9999
                  if (iipl.eq.1) then
                     jauxpl = pgesl_gede(isl)
                  else
                     jauxpl = xgesl_gede(jauxpl)
                  endif
                  if (jauxpl.eq.0) go to 21
                  ipl = mgesl_gede(jauxpl)

*                 **** check if plane belongs to sl
                  if (ogede_gesl(ipl).ne.isl) then
                     print *,' () pkpick: ipl, isl, ogede_gesl(ipl)=',
     +                    ipl, isl, ogede_gesl(ipl)
                  endif

*                 **** check layer
                  if (layer.gt.0.and.igede_lay(ipl).ne.layer) go to 20
*                 **** check sector
                  if (sector.gt.0.and.igede_sec(ipl).ne.sector) go to 20
*                 **** check component
                  if (cmp.gt.0.and.igede_cmp(ipl).ne.cmp) go to 20

*                 **** store plane
                  if (npldis.eq.ndetmx) then
                     print *,' () pkpick: npldis, ndetmx=',
     +                    npldis, ndetmx
                     stop
                  endif

                  npldis = npldis + 1
                  ipldis(npldis) = ipl
                  zpldis(npldis) = fgede_zmin(ipl)
 20            continue
 21            continue
            elseif (igesl_cmp(isl).eq.7
     +              .or.(igesl_cmp(isl).ge.13
     +                   .and.igesl_cmp(isl).le.14)) then ! CAL
               npldis = npldis + 1
               ipldis(npldis) = 1000000 + isl ! store sl for ECAL
               zpldis(npldis) = fgesl_z1(isl)
            endif
 10      continue

         if (lwallzg) then
*           **** loop over walls
            do 40 iwl=1,iq(jgwal+2)
*              **** store wall as plane with negative sign
               if (npldis.eq.ndetmx) then
                  print *,' () pkpick: npldis, ndetmx=', npldis, ndetmx
                  stop
               endif

               npldis = npldis + 1
               ipldis(npldis) = -iwl ! store wall with negative id
               zpldis(npldis) = 0.5 *
     +              (fgwal_zmin(iwl) + fgwal_zmax(iwl))
 40         continue
         endif

*        **** sort planes according to z
         call sortzv(zpldis,indexz,npldis,+1,idirzg+1,0)

*        **** display planes
         do 30 ipl_i=1,npldis
            ipl = ipldis(indexz(ipl_i))
            if (ipl.lt.1000000) then
               if (ipl.gt.0) then
                  isl = ogede_gesl(ipl)
                  if (pickpl) call pkplab(ipl,chopt)
                  if (pickhit) call pkhit (ipl,idmc,chopt)

                  if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
     +                 call pkghit(isl,ipl,idmc,chopt)
               else
                  if (pickwall) call pkwall(-ipl,chopt)
               endif
            else
**               isl = mod(ipl,1000000)
**               if (pickpl) call pkplac(isl,chopt) ! pick ECAL blocks
**               if (pickhit) call pkhitc(isl,0,idmc,chopt)
**               if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
**     +              call pkmcal(isl,idmc,chopt)
            endif
 30      continue

*        **** MC particles
         if (pickmc.and.(index(chopt,'M').gt.0.or.lmczg))
     +        call pkmc(idmc,mv,islsta,islend,chopt)

*        **** MC vertices
         if (pickmv.and.index(chopt,'V').gt.0) call pkmv(idmc,mv,chopt)

*        **** tracks ...
         if (pickrc.and.(lrczg.or.index(chopt,'T').gt.0))
     +        call pkrtra(idmc,idrc,islsta,islend,chopt)

*        **** segments ...
         if (pickrs.and.(lrsegzg.or.index(chopt,'T').gt.0))
     +        call pkrseg(idmc,idrs,islsta,islend,chopt)

      elseif (modezg.eq.3) then
*        **** display single plane
         if (pickpl) call pkplab(pl,chopt)
         if (pickhit) call pkhit (pl,idmc,chopt)

         if (pickmimp.and.(index(chopt,'G').ne.0.or.lmimpzg))
     +        call pkghit(ogede_gesl(pl),pl,idmc,chopt)
      else
         print *,' () pkpick: invalid redraw mode=', modezg
      endif

*     **** redraw highlighted object
      if (idpickzg.gt.0) then
         call iselnt(nt_detzg)
         call isclip(1)
         if (pickmc) then
            mc = idpickzg
            savecol = comczg    ! save normal MC color
            comczg = 6.         ! set highlight color
            call dimc(mc,mv,islsta,islend,'O')
            comczg = savecol    ! reset normal color
         elseif (pickrc) then
            rc = idpickzg
            savecol = corczg    ! save normal RC color
            corczg = 6.         ! set highlight color
            call dirtra(idmc,rc,islsta,islend,chopt)
            corczg = savecol    ! reset normal color
         elseif (pickrs) then
            rs = idpickzg
            savecol = corszg    ! save normal RS color
            corszg = 6.         ! set highlight color

c            call dirseg(idmc,rs,islsta,islend,chopt)
             call di1rseg(rs,1,ngesl(),' ')
c            call di1rseg(rs,islsta,islend,chopt)

            corszg = savecol    ! reset normal color

         elseif (pickmimp) then
            mimp = idpickzg
*           **** hit coordinate
            wcm(1) = fmimp_x(mimp)
            wcm(2) = fmimp_y(mimp)
            wcm(3) = fmimp_z(mimp)
*           **** projection
            call dipro(wcm,xxx(1),yyy(1))
            call isplci(1)
            call igset('PMCI',6.)
            call ismk(20)
            call ismksc(1.)
            call ipm(1,xxx(1),yyy(1))
         elseif (pickhit) then
            hit = idpickzg
            savecol = cowirzg
            cowirzg = 6.
            call dihit(ihitb_gede(hit),hit,idmc,chopt)
            cowirzg = savecol
         elseif (pickpl) then
            pl = idpickzg
            savecol = coplbzg    ! save normal plane color
            coplbzg = 6.         ! set highlight color
            call diplab(pl,chopt) ! display highlighted plane
            coplbzg = savecol    ! reset normal color
         elseif (pickmv) then
         elseif (pickrv) then
         elseif (pickwall) then
         endif
      endif

*     **** update wk and go to alpha mode
      call iuwk(0,1)
      call igterm()

*     **** print pick info
**      print *,' pkpick: pick result idpickzg=', idpickzg,
**     +     ' rpickzg=', rpickzg

      if (idpickzg.gt.0) then
         if (pickmc) then
            mc = idpickzg
            pmc = sqrt( fmtra_px(mc)**2 + fmtra_py(mc)**2
     +                + fmtra_pz(mc)**2 )
            call tudecay(mc,cname,corigin,cdestiny)
            print 102, mc, cname, pmc, fmtra_px(mc), fmtra_py(mc),
     +           fmtra_pz(mc), corigin, cdestiny
 102        format(
     +        /'***********************************************',
     +        /'*      mc=', i6, 15x, 'name=', a10,'*',
     +        /'*       p=', f9.2,14x,             'px=', f9.3,' *',
     +        /'*      py=', f9.2,14x,             'pz=', f9.3,' *',
     +        /'*  origin=', 1x, a34, 1x, '*',
     +        /'* destiny=', 1x, a34, 1x, '*'
     +        /'***********************************************')

         elseif (pickrc) then
            rc = idpickzg
            if (frtra_pf(rc).ne.0.) then
               prc = 1. / frtra_pf(rc)
            else
               prc = 0.
            endif
            print 105,rc,irtra_fit(rc),prc,frtra_zf(rc),frtra_txf(rc),
     +           frtra_tyf(rc),frtra_chi(rc),(irtra_hsi(rc)
     +           +irtra_hin(rc)+irtra_hou(rc)+irtra_hri(rc)+
     +           irtra_hca(rc)+irtra_htr(rc)+irtra_hmu(rc))
 105        format(
     +        /'***********************************************',
     +        /'*      rc=', i6, 16x, 'fit=', i9,' *',
     +        /'*       p=', f9.2,14x,             'zf=', f9.3,' *',
     +        /'*      tx=', f9.2,14x,             'ty=', f9.3,' *',
     +        /'*    chi2=', f9.2,12x,'nhit=',i9,' *',
     +        /'***********************************************')

         elseif (pickrs) then
            rs = idpickzg
            if (frseg_pf(rs).ne.0.) then
               prsf = 1. / frseg_pf(rs)
            else
               prsf = 0.
            endif
            if (frseg_pe(rs).ne.0.) then
               prse = 1. / frseg_pe(rs)
            else
               prse = 0.
            endif

c Use component definitions from include/arte/RSEG_cmp.hh, RSEG_cmp.fi
            s = ' '
            c = irseg_cmp(rs)
            if (c.lt.0) s(lenocc(s)+2:) = 'Killed!'
            if (and(c,         1).ne.0) s(lenocc(s)+2:) = 'VDS'   ! Vertex Detector
            if (and(c,         2).ne.0) s(lenocc(s)+2:) = 'PC'    ! Pattern Tracker
            if (and(c,         4).ne.0) s(lenocc(s)+2:) = 'MC'    ! Magnet Tracker
            if (and(c,         8).ne.0) s(lenocc(s)+2:) = 'Muon'  ! Muon Detector
            if (and(c,        16).ne.0) s(lenocc(s)+2:) = 'ECAL'  ! Ecal
            if (and(c,        32).ne.0) s(lenocc(s)+2:) = 'Target'! Target Constraint
            if (and(c,        64).ne.0) s(lenocc(s)+2:) = 'TC'    ! Trigger Tracker, betw RICH and ECAL
            if (and(c,       128).ne.0) s(lenocc(s)+2:) = 'Bit7'  ! not assigned yet
            if (and(c,       256).ne.0) s(lenocc(s)+2:) = 'Bit8'  ! not assigned yet
            if (and(c,       512).ne.0) s(lenocc(s)+2:) = 'Bit9'  ! not assigned yet
            if (and(c,      1024).ne.0) s(lenocc(s)+2:) = 'Bit10' ! not assigned yet
            if (and(c,      2048).ne.0) s(lenocc(s)+2:) = 'Bit11' ! not assigned yet
            if (and(c,      4096).ne.0) s(lenocc(s)+2:) = 'Bit12' ! not assigned yet
            if (and(c,      8192).ne.0) s(lenocc(s)+2:) = 'Bit13' ! not assigned yet
            if (and(c,     16384).ne.0) s(lenocc(s)+2:) = 'Bit14' ! not assigned yet
            if (and(c,     32768).ne.0) s(lenocc(s)+2:) = 'Bit15' ! not assigned yet
            if (and(c,     65536).ne.0) s(lenocc(s)+2:) = 'Bit16' ! not assigned yet
            if (and(c,    131072).ne.0) s(lenocc(s)+2:) = 'Bit17' ! not assigned yet
            if (and(c,    262144).ne.0) s(lenocc(s)+2:) = 'Bit18' ! not assigned yet
            if (and(c,    524288).ne.0) s(lenocc(s)+2:) = 'Bit19' ! not assigned yet
            if (and(c,   1048576).ne.0) s(lenocc(s)+2:) = 'Bit20' ! not assigned yet
            if (and(c,   2097152).ne.0) s(lenocc(s)+2:) = 'Bit21' ! not assigned yet
            if (and(c,   4194304).ne.0) s(lenocc(s)+2:) = 'Bit22' ! not assigned yet
            if (and(c,   8388608).ne.0) s(lenocc(s)+2:) = 'Bit23' ! not assigned yet
            if (and(c,  16777216).ne.0) s(lenocc(s)+2:) = 'Bit24' ! not assigned yet
            if (and(c,  33554432).ne.0) s(lenocc(s)+2:) = 'TRD'   ! TRD straw device type
            if (and(c,  67108864).ne.0) s(lenocc(s)+2:) = 'RICH'  ! Cherenkov Counter device type
            if (and(c, 134217728).ne.0) s(lenocc(s)+2:) = 'HiPT'  ! HiPT Chamber device type
            if (and(c, 268435456).ne.0) s(lenocc(s)+2:) = 'ITR'   ! MSGC device type
            if (and(c, 536870912).ne.0) s(lenocc(s)+2:) = 'OTR'   ! honeycomb wire chamber device type
            if (and(c,1073741824).ne.0) s(lenocc(s)+2:) = 'Sili'  ! silicon strip device type

            if (s(14:15).eq.'  ') s(14:15) = ' *'

            print 106,rs,irseg_fit(rs),irseg_err(rs),
     +           frseg_xf(rs),frseg_yf(rs),frseg_zf(rs),
     +           frseg_xe(rs),frseg_ye(rs),frseg_ze(rs),
     +           frseg_txf(rs),frseg_tyf(rs),prsf,
     +           frseg_txe(rs),frseg_tye(rs),prse,
     +           frseg_chi(rs),irseg_cmp(rs),s,
     +      irseg_nhit(rs),irseg_npar(rs),frseg_time(rs),frseg_dtim(rs)
 106        format(
     +        /'***********************************************',
     +        /'*   rs=',i6,'     fit=',i6,'    err=',i6,'    *',
     +        /'*   xf=',f8.2,'    yf=',f8.2,'   zf=',f9.3,' *',
     +        /'*   xe=',f8.2,'    ye=',f8.2,'   ze=',f9.3,' *',
     +        /'*  txf=',f10.5,' tyf=',f10.5,' pf=',f7.2,'   *',
     +        /'*  txe=',f10.5,' tye=',f10.5,' pe=',f7.2,'   *',
     +        /'* chi2=',f9.2,' cmp= 0x',z8,a,
     +    /'* nhit=',i3,'  npar=',i3,'  time =',f5.1,' +-',f5.1,5x,'*',
     +        /'***********************************************')
c Additional data: rtra= , rbeg=, rend=, rccl=, err=, mtra=,  npar=, rpnt=

         elseif (pickmimp) then
            mimp = idpickzg
            call tudecay(omimp_mtra(mimp),cname,corigin,cdestiny)

            print 101, mimp, omimp_mtra(mimp), cname, fmimp_x(mimp),
     +           fmimp_tx(mimp), fmimp_y(mimp), fmimp_ty(mimp),
     +           fmimp_p(mimp), imimp_gede(mimp)
 101        format(/'***********************************************',
     +             /'* mimp=', i6, 22x,              'mc=', i5,'   *',
     +             /'*      ', 26x,                'name=', a8,   '*',
     +             /'*    x=', f9.2,19x,             'tx=', f7.3,' *',
     +             /'*    y=', f9.2,19x,             'ty=', f7.3,' *',
     +             /'*    p=', f9.2,19x,             'pl=', i6, '  *',
     +             /'***********************************************')
         elseif (pickhit) then
            hit = idpickzg
            print 104, hit, ihitb_gede(hit), fhitb_z(hit), fhitb_q(hit),
     +           fhitb_x(hit), fhitb_r(hit), tuhrtra(hit)
 104        format(/'***********************************************',
     +             /'*  hit=', i6, 22x,              'pl=', i5,'   *',
     +             /'*    z=', f9.2,19x,             ' q=', f7.4,' *',
     +             /'*    x=', f9.2,19x,             ' r=', f7.4,' *',
     +             /'* rtra=', i6  ,22x,             '   ', 6x, '  *',
     +             /'***********************************************')
         elseif (pickpl) then
            pl = idpickzg
            alpha = 57.296 * atan2(fgede_sin(pl),fgede_cos(pl))
            arot  = 57.296 * atan2(fgede_rot(2,pl),fgede_rot(1,pl))

            call uhtoc(iq(hqnede_hwc(1,pl)),12,hwc,12)
            do i=1,12
               if (ichar(hwc(i:i)).lt.32) hwc(i:i) = ' '
            end do
            print 103, pl, hwc,
     +           ogede_gesl(pl), iq(hqnesl_name(ogede_gesl(pl))),
     +           igede_lay(pl),  igede_sec(pl),
     +           igede_cmp(pl),  igede_shp(pl),
     +           alpha,          arot,
     +           fgede_zmin(pl), fgede_zmax(pl),
     +           fgede_xmin(pl), fgede_xmax(pl),
     +           fgede_ymin(pl), fgede_ymax(pl),
     +           fgede_sxmn(pl), fgede_sxmx(pl),
     +           fgede_symn(pl), fgede_symx(pl)
 103        format(
     +        /'***********************************************',
     +        /'*      pl=', i6,1x,a,'   sl=', i6,1x,a4,'*',
     +        /'*     lay=', i6,  15x,  'sec=', i6, '     *',
     +        /'*     cmp=', i6,  15x,  'shp=', i6, '     *',
     +        /'*     ste=', f9.2,11x,  ' rot=', f9.2,'  *',
     +        /'*    zmin=', f9.2,11x,  'zmax=', f9.2,'  *',
     +        /'*    xmin=', f9.2,11x,  'xmax=', f9.2,'  *',
     +        /'*    ymin=', f9.2,11x,  'ymax=', f9.2,'  *',
     +        /'*    sxmn=', f9.2,11x,  'sxmx=', f9.2,'  *',
     +        /'*    symn=', f9.2,11x,  'symx=', f9.2,'  *',
     +        /'***********************************************')

         elseif (pickmv) then
         elseif (pickrv) then
         elseif (pickwall) then
         else
            print *,' () pkpick: no pick mode selected'
         endif
      else
         print *,' pkpick: nothing picked'
      endif

 999  end
