*CMZ :  4.01/01 26/01/96  15.23.36  by  Rainer Mankel
*CMZ :  4.01/00 28/09/95  19.57.49  by  Rainer Mankel
*-- Author :    Rainer Mankel   28/09/95

      subroutine dmseed()

*     **** set up domain layer seeding table
      implicit none

#include "rang/zdomain.fi"
#include "rang/zfout.fi"
      integer max_lay
      parameter (max_lay=10)
      integer slay(max_lay), lay, ndom_patt, domain, window, method,
     +     delta_lay, inter_leave, maxdom_patt


      nseedh_ds = 0        ! reset seed tables
      nseedv_ds = 0        !

      ndom_patt = 0
      maxdom_patt = 2      ! only 2 (the last) pattern domain

      inter_leave = 2      ! max layer difference

      do 10 domain=n_dm,1,-1    ! backward loop over domains
       if (scope_dm(domain).ne.3) go to 10 ! only pattern area
       ndom_patt = ndom_patt + 1
       if (ndom_patt.gt.maxdom_patt) go to 11
       do window=win1_dm(domain),win1_dm(domain)+nwin_dm(domain)-1
        do method=2,3
         do lay=1,nlayer_dw(method,window)
          if (lay.le.max_lay) then
           if (lay.eq.1) then
            slay(lay) = layer1_dw(method,window)
           else
            slay(lay) = nxtlay_dl(method,slay(lay-1))
           endif
          endif
         enddo

         do delta_lay=1,inter_leave
          do lay=min(nlayer_dw(method,window),max_lay),1+delta_lay,-1
           if (method.eq.2) then
            if (nseedh_ds.lt.maxseedh_ds) then
             nseedh_ds = nseedh_ds + 1
             dlayh_ds(1,nseedh_ds) = slay(lay-delta_lay)
             dlayh_ds(2,nseedh_ds) = slay(lay)
            else
             print *,' () dmseed: overflowing nseedh_ds=',nseedh_ds
            endif
           else
            if (nseedv_ds.lt.maxseedv_ds) then
             nseedv_ds = nseedv_ds + 1
             dlayv_ds(1,nseedv_ds) = slay(lay-delta_lay)
             dlayv_ds(2,nseedv_ds) = slay(lay)
            else
             print *,' () dmseed: overflowing nseedv_ds=',nseedv_ds
            endif
           endif
          enddo ! layers
         enddo ! delta_lay
        enddo ! methods
       enddo ! windows
 10   continue ! domains
 11   continue

      if (llog_zfout) then
         print *,' dmseed: # horizontal seeds installed=', nseedh_ds
         print *,' dmseed: # vertical   seeds installed=', nseedv_ds
      endif

      end
