#ifndef rangerRadPhoton_HH
#define rangerRadPhoton_HH

#include "arte/arte.hh"
// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerRadPhoton
// node class for energy loss due to single radiated photon

#include "rang/Node.hh"
#include "rang/Thin.hh"
#include "rang/Volume.hh"

class rangerRadPhoton : public rangerThin {

public:
  rangerRadPhoton();
  rangerRadPhoton(const float energy,const float eError,
		  const float zRad,rangerNode* n);
  ~rangerRadPhoton(){};   
  
  inline float ms() const {return 0;}
  inline float msPlain() const { return 0; }
  inline float dz(){return 0;}
  inline int plane(){return 0;}

  virtual void processNoise(rangerParticleType pType);  
                         // apply process noise to state of this node
  virtual void predProcessNoise(rangerParticleType pType);  
                         // apply process noise to state of  node
private:
  float photEnergy;  // energy of radiated photon
  float photError;
};

#endif
