#include "rang/zfparext.hh"// 
//  Author:  Alexander Spiridonov              Created:  23.05.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextsvm.C
//            swim parameters from VDS position to MUON position 


#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"

extern "C"
{
  void rgextsvm_(
		 float&  z_in,     // z_values for input parameters
		 float* p_in,      // input parameters (x,y,tx,ty,q/p)
		 float&  z_out,    // z_values for input parameters
		 float* p_out      // input parameters (x,y,tx,ty,q/p)   
		 )
    {
      int ierror;
      double z1_in, p1_in[5], z1_out, p1_out[5], rkd1[25];

      z1_in  = zfparext_.zmin_magn;
      z1_out = zfparext_.zmax_magn;
      p1_in[0] = p_in[0] + p_in[2] * (zfparext_.zmin_magn - z_in);
      p1_in[1] = p_in[1] + p_in[3] * (zfparext_.zmin_magn - z_in);
      p1_in[2] = p_in[2];
      p1_in[3] = p_in[3];
      p1_in[4] = p_in[4];

      rk5clip_(z1_in, p1_in, z1_out, p1_out,rkd1,ierror);

      p_out[0] = p1_out[0] + p1_out[2] * (z_out - zfparext_.zmax_magn);
      p_out[1] = p1_out[1] + p1_out[3] * (z_out - zfparext_.zmax_magn);
      p_out[2] = p1_out[2];
      p_out[3] = p1_out[3];
      p_out[4] = p1_out[4];
    }
}
