// 
//  Author:  Rainer Mankel                     Created:  19-May-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgnamdom_
// Takes domain name as character string and search the corresponding
// rangerDomain pointer in the domain list in the standard ranger domain 
// object rangerDO. The pointer is returned as return value.

// A null pointer is returned when no appropriate domain is found. 

#include <string>
#include <vector.h>

#include "rang/DomObj.hh"
#include "rang/Domain.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  rangerDomain* rgnamdom_(char* c,const int nc) { 
    string s(c,3);
    vector<rangerDomain*>::iterator dit=rangerDO->findDom(s);
    if (dit != rangerDO->dom().end()) {
      //cout << "rgnamdom: found domain " << **dit << endl;
      //cout << " .... nc=" << nc << endl;
      return *dit;
    }
    else {
      return 0;
    }
  }
}
