// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgxproint_
// Fortran interface to rangerXPro::xProInt(...)
// This is complicated:
// checks if the horizontal projection candidate passes intermediate
// domains without a hit in the x projection found. The corresponding
// domain windows are then not in the list of navigable windows, and
// therefore not be used for vertical tracking.
// rgxproint interpolates the corresponding windows and puts them on
// the list of navigable windows, so that these detectors can be
// used for vertical tracking. 

#include "rang/Domain.hh"
#include "rang/DomWin.hh"
#include "rang/DomObj.hh"
#include "rang/XPro.hh"
#include "rang/XWin.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgxproint_() {
    rangerDO->xpro()->xProInt(rangerDO->dom());
  }
}
