** 
**  Author   Alexander Spiridonov              Created:  03-Jul-2000
**         
**  Email:   spiridon@ifh.de                   HERA-B Collaboration
** 

      subroutine tfdownqp(zs,xs,ys,txs,tys,nqpmax,nqp,qp,eqp)
*
*     define list of qp values for seed  
*     for downstream propagation through main tracker
*
*     input : zs,xs,ys,txs,tys  - seed parameters
*             nqpmax - maximal value of qp values ( minimal 3)      
*     output : nqp  - number of qp values
*              qp() - array of q/p for seeds 
*
      implicit none

      integer nqpmax,nqp
      real zs,xs,ys,txs,tys
      real qp(*),eqp(*) 
      real teta
      integer ntry,itry
      data ntry/20/
      real dqp,qpmax,qp_try
      data dqp/0.01/,qpmax/0.2/
     
      nqp = 1
      qp(nqp) = 0.
      eqp(nqp) =1.

      go to 999                                 !  simple solution

**      nqp = 3
**      qp(1) = 0.
**      qp(2) = -0.8
**      qp(3) =  0.8

      teta = sqrt( txs**2 + tys**2)
      nqp = 0
***      if(teta - 0.02.gt.qpmax) go to 999

      nqp = nqp + 1
      qp(nqp) = 0.2
      eqp(nqp) = 0.01
      nqp = nqp + 1
      qp(nqp) = -0.2
      eqp(nqp) = 0.01

      nqp = nqp + 1
      qp(nqp) = 0.1
      eqp(nqp) = 0.01
      nqp = nqp + 1
      qp(nqp) =  -0.1
      eqp(nqp) = 0.01

      nqp = nqp + 1
      qp(nqp) = 0.
      eqp(nqp) = 1.
  
      go to 999

      nqp = nqp + 1
      qp(nqp) = 0.05
      eqp(nqp) = 0.01
      nqp = nqp + 1
      qp(nqp) = -0.05
      eqp(nqp) = 0.01

      go to 999   

      if(teta.lt.0.02) teta = 0.02
      do 1 itry = 1,ntry
         if(teta.le.0.02.and.itry.eq.1) go to 1
         qp_try = (teta - 0.02) + float(itry - 1) * dqp
         if(abs(qp_try).gt.qpmax) go to 999
**         print '("tfdownqp.F : qp_try ",f8.3,i4)',qp_try,nqp
         if(nqp+1.ge.nqpmax) go to 999
         nqp = nqp + 1
         qp(nqp) = qp_try
*         eqp(nqp) = dqp * 0.5
         eqp(nqp) = 1.
         if(nqp+1.ge.nqpmax) go to 999
         nqp =  nqp + 1
         qp(nqp) = -qp_try
*         eqp(nqp) = dqp * 0.5
         eqp(nqp) = 1.
 1    continue

 999  continue
**      print '("tfdownqp.F : dqp,teta,ntry,nqp " ,2f8.3,2i4)'
**     +     ,dqp,teta,ntry,nqp
      return
      end
