*-- Author :    Rainer Mankel   02/06/96
*-- changed:    A. Spiridonov   25/02/98

      subroutine tfmprep(ift,istat)

*     **** prepare track for magnet continuation

      implicit none

#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/FLAGWhit.hh"
#include "pris/hgmagnhelp.fi"
#include "pris/zpstat.fi"

      integer ift,jft,i,j,izf,jzf,kzf,istat
      
      integer imc,nnmimp,mimp,gold,jgold
      real pnoise,pnoise1
    
      real qptmax,qptmin,qpt,tfqptest,z,x,tx
      parameter (qptmax=0.96)
      parameter (qptmin=0.0025)

#include "auto/MTRA.fi"
 
      integer muon1,muon2,pion1,pion2,ii,gcode
      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )

#include "rang/descend.fi"
#include "auto/TOPP.fi"

      logical electron

      integer mcass   
      real p_real,p_mc,fracmc
      integer message_id_1

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"

      if (stat_ft(ift).eq.3.or.stat_ft(ift).eq.5) then
         istat = 0
         kzf = last_ft(ift)
         electron_id(ift) = .false.

         if (n_zf.lt.nzfmx) then ! create hardcopy of lowest-z hit
            n_zf = n_zf + 1
            izf = n_zf

            do i=1,4
               xx_zf(i,izf) = xs_zf(i,kzf)
               do j=1,4
*                  cx_zf(i,j,izf) = cs_zf(i,j,kzf)
                  cx_zf(i,j,izf) = cs_zf(i,j,kzf) * 1.7    ! 28.04.98
               enddo
            enddo
            do i=1,dimm
               xm_zf(i,izf) = xm_zf(i,kzf)
               do j=1,dimm
                  cm_zf(i,j,izf) = cm_zf(i,j,kzf)
               enddo
               do j=1,4
                  h_zf(i,j,izf) = h_zf(i,j,kzf)
               enddo
            enddo
            z_zf(izf)      = z_zf(kzf)
            ch_zf(izf)     = ch_zf(kzf)
            cht_zf(izf)    = cht_zf(kzf)
            hit_zf(izf)    = hit_zf(kzf)
*            nhit_zf(izf)   = nhit_zf(kzf)
                                            nhit_zf(izf)   = 1
            sign_zf(izf)   = sign_zf(kzf)
            plane_zf(izf)  = plane_zf(kzf)
            domlay_zf(izf) = domlay_zf(kzf)
            prev_zf(izf)   = prev_zf(kzf)
            prevs_zf(izf)  = prevs_zf(kzf)
            fault_zf(izf)  = fault_zf(kzf)
            pfault_zf(izf) = pfault_zf(kzf)
            dim_zf(izf)    = dim_zf(kzf)
            shadow_zf(izf) = shadow_zf(kzf)
#ifdef RT_WHIT
            whit_zf(izf)   = whit_zf(kzf)
#else
            whit_zf(izf)   = 0
#endif
            if (nca_ft.lt.ncamx) then ! create new candidate
               nca_ft = nca_ft + 1 
               jft = nca_ft
               first_ft(jft) = izf
               last_ft(jft) = izf
               prev_ft(jft) = ift
               gen_ft(jft) = 1
               nhit_ft(jft) = 1
               nfault_ft(jft) = 0
               quality_ft(jft) = quality_ft(ift)
               stat_ft(jft) = 4
               alive_ft(jft) = .true.
               mature_ft(jft) = .false.
	            else
               print *,' () tfmprep: overflowing nca_ft=',nca_ft
               istat = -10
            endif
         else
            print *,' () tfmprep: overflowing n_zf=',n_zf
            istat = -10
         endif
      else
**         print *,' () tfmprep: invalid stat_ft=',stat_ft(ift)
**     +            ,' ift=',ift
         call mepric(message_id_1,1,' tfmprep: invalid stat_ft')
         istat = -10
      endif

      do i=1,4
         cx_zf(i,5,izf) = 0.
         cx_zf(5,i,izf) = 0.
      enddo

      z = z_zf(izf)
      x = xx_zf(1,izf)
      tx = xx_zf(3,izf) 
**                                 qpt = tfqptest(z,x,tx)    !  very old
      qpt = - tfqptest(z,x,tx) * 1.031

      if(abs(qpt).lt.qptmin) qpt = sign(qptmin,qpt)

      if (abs(qpt).lt.qptmax) then
        xx_zf(5,izf) = qpt*dsqrt(1.+xx_zf(3,izf)*xx_zf(3,izf))
     +        /dsqrt( 1.+xx_zf(3,izf)*xx_zf(3,izf)
     +                  +xx_zf(4,izf)*xx_zf(4,izf) )

**      cx_zf(5,5,izf) = 1.7388                              ! very old

#ifdef RT_TEST

        call hf1(108,whit_zf(kzf),1.)
        call hf1(109,z_zf(kzf),1.)

*****        call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)      

        call tfremcft(ift,mcass,fracmc)
*        print '("tfmprep : ift,imc,frac ",2(x,i4),x,f8.3)'
*     +         ,ift,mcass,fracmc
        if (mcass.ne.0.and.fracmc.gt.0.99) then
          imc = mcass
          p_mc= sqrt( fmtra_px(imc)**2 
     +              + fmtra_py(imc)**2
     +              + fmtra_pz(imc)**2 )

          do ii=1,pstat_nrefmag
            if(pstat_refmag(ii).eq.imc) then
              p_real = 1./xx_zf(5,izf)
              if(imc.eq.muon2.or.imc.eq.pion2) then
                p_mc = - p_mc
              end if
              pnoise = p_real/p_mc - 1.    
              if(imc.gt.0.and.abs(p_mc).gt.1) then
                if((imc.eq.muon1).or.(imc.eq.muon2)) then
                  call hf1(104,pnoise,1.)
                  call hf2(106,p_mc,p_real,1.)          
                else if(imc.eq.pion1.or.imc.eq.pion2) then
                  call hf1(105,pnoise,1.)
                  call hf2(107,p_mc,p_real,1.)          
                  call hf2(117,p_mc,p_real,1.)          
                end if

*                if((abs(p_real/p_mc).gt.10.).or.
*     +            (abs(p_mc/p_real).gt.10.)     )then
*
*                  print *,'====================================='
*                  print *,'====================================='
*                  print '("mprep: m,p,pmc ",i4,f8.3,f8.3 )'
*     +                   ,imc,p_real,p_mc
*                end if

              end if
            end if
          end do 
        end if        ! end  of mimp > 0 

#endif

      else
        xx_zf(5,izf) = sign(qptmax,qpt)
      end if

      cx_zf(5,5,izf) = 0.004 * abs( xx_zf(5,izf) )**2

**    electron identification

      electron_id(jft) = .false.
**
#ifdef RT_TEST

        call tuhmimp(hit_zf(izf),imc,mimp,nnmimp)
        pnoise1 = sqrt(fmtra_px(imc)**2+fmtra_py(imc)**2
     +               +fmtra_pz(imc)**2)
      pnoise = 1./dabs(xx_zf(5,izf))
*     **** loop over golden Bs
      do gold=1,pstat_ngold
        do jgold=1,4  ! loop over stable golden particles
          if(pstat_gold(jgold,gold).eq.imc) then
            print '("prep i m z p pmc d/qp qp",2(xi4),5(x,f8.3))'
     +             ,ift,imc,z_zf(izf)
     +             ,(1./xx_zf(5,izf)),pnoise1
     +             ,(1./pnoise1 - dabs( xx_zf(5,izf) ) )
     +             /dabs( xx_zf(5,izf))
     +             ,xx_zf(5,izf)
            print '("prep nh x qu",i3,5(x,f8.3))'
     +      ,nhit_ft(ift)
     +      ,xx_zf(1,izf),xx_zf(2,izf),xx_zf(3,izf),xx_zf(4,izf)
     +      , quality_ft(jft)

          end if
        end do
      end do
#endif

      fault_zf(izf) = 0

#ifdef TFVERBOSE
      print *,' tfmprep: set qpt=',qpt,' cov(qpt)=',cx_zf(5,5,izf)
#endif

#ifdef OLDVERS
      jzf = izf
      do i=2,nhit_ft(ift)
         jzf = prevs_zf(jzf)
         if (jzf.le.0) then
            print *,' () tfmprep: inconsistent jzf=',jzf
            go to 999
         endif
         do j=1,5
            xx_zf(j,jzf) = xs_zf(j,jzf)
         enddo
         prev_zf(jzf) = prevs_zf(jzf)
      enddo
#endif

      if(cp_zf(4,4,last_ft(ift)).lt.0.) then
         print *,'tfmprep istat ift kfz jft izf cx44 '
     +          ,stat_ft(ift),ift,kzf,jft,izf,cx_zf(4,4,izf)
      end if

 999  end
