*-- Author :    Rainer Mankel   01/02/95

      subroutine tfpp(imc,p_befmag,p_aftmag)

*     **** give momentum before & after magnet
      implicit none

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
#include "auto/MIMP.fi"

**+cde,hgmagnhelp.
      integer imc, n1, n2, iso, nso, imim
      real charge, mass, p_befmag, p_aftmag, z, zbef, zaft
      character*20 cname

#include "pris/zmh.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
#include "auto/MIMP.ff"

*     **** initialize /zmh/ if needed
      call tusomh()

      zbef = ffeld_z(1) - ffeld_r(1)
      zaft = ffeld_z(1) + ffeld_r(1)

*     **** loop over mimps in sorted order
      nso = nmimmh(imc)
      n1 = 0
      n2 = 0
      p_befmag = 0.
      p_aftmag = 0.

      do 10 iso=1,nso
       imim = imimmh( istamh(imc) + iso )
       if (imim.le.0.or.imim.gt.iq(jmimp+2)) then
        print *,' () tfpp: invalid imim=',imim
        go to 10
       endif

       z = fmimp_z(imim)
       if (omimp_mtra(imim).ne.imc) go to 10
       if (n1.eq.0) then
        if (z.gt.zbef) n1 = iso
       elseif (n2.eq.0) then
        if (z.gt.zaft) then
         n2 = iso
         go to 11
        endif
       else
        print *,' () tfpp: n1, n2=', n1, n2
       endif
 10   continue
 11   continue

      if (n1.gt.0) p_befmag = abs(fmimp_p(imimmh( istamh(imc) + n1 )))
      if (n2.gt.0) p_aftmag = abs(fmimp_p(imimmh( istamh(imc) + n2 )))

*     **** charge correction
      call tupaty(omtra_topp(imc),cname,charge,mass,'G')

      p_befmag = p_befmag * charge
      p_aftmag = p_aftmag * charge

      end



