*-- Author :    A. Spiridonov   10/07/98

#define NEWNAV


#ifdef NEWNAV
      subroutine tftcren
#else
      subroutine tftcre
#endif

*
*     track reconstruction in TC chambers by means
*     of propagation of track segments from PC 

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"

#include "rang/FIXtrit.hh"

*      integer maxlep
*      parameter (maxlep=10)

      integer ift,iiseg,ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep

      logical init

      save init
      data init /.false./

      integer muon1,muon2,pion1,pion2
      integer nh,nh_PC,imimp,jaux,imc,nhmimp,imcass,NRSEG_rec
      real fracmc

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )
      equivalence ( pstat_gold(3,1),pion1 )
      equivalence ( pstat_gold(4,1),pion2 )

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      l_diag = .false.
      diag_level = 0

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** do the work

*      call tftcms         ! study mult.scat. between PC and TC

      if(jrseg.le.0) go to 999
      if(NRSEG().lt.1) go to 999

      NRSEG_rec = NRSEG()

      do iiseg = 1,NRSEG_rec
        seg_PC_TC(iiseg) = 0      
        seg_TC_PC(iiseg) = 0 
      end do

      do 10 iiseg=1,NRSEG_rec     ! loop over reconstructed segments

        if (irseg_fit(iiseg).ne.0) go to 10 ! select charged track 
  
        if (prseg_rend(iiseg).gt.0) go to 10 ! already continued 
 
        if( (IAND(irseg_cmp(iiseg),rsegc_patt).ne.rsegc_patt.and.
     +      IAND(irseg_cmp(iiseg),rsegc_magt).ne.rsegc_magt).or. 
     +      (frseg_ze(iiseg) - frseg_zf(iiseg)).lt.30..or.
     +      IAND(irseg_cmp(iiseg),rsegc_bitsign).eq.rsegc_bitsign)
     +       go to 10     !  reject segment

**        print '(" tftcren.F : segment to be continued ",i4)',iiseg

*        if( irseg_cmp(iiseg).ne.rsegc_pamg
*     +  .or.frseg_zf(iiseg).gt.450.) go to 10  ! select good segments

***        if( (IAND(irseg_cmp(iiseg),rsegc_patt).ne.rsegc_patt)
***     +  .or.(IAND(irseg_cmp(iiseg),rsegc_magt).ne.rsegc_magt)
***     +  .or.(frseg_zf(iiseg).gt.450.)  ) go to 10  !   reject segment

#ifdef TC_TEST
*           define inc,mimp

            nh_PC = 0
            imimp = 0
            jaux = prseg_hitb(iiseg)
  27        if(jaux.eq.0) go to 30 
            nh = mrseg_hitb(jaux)
            if(nh.gt.0) nh_PC = nh
            jaux = xrseg_hitb(jaux)
            go to 27 
  30        continue

            if(nh_PC.gt.0) then
              call tuhmimp(nh_PC,imc,imimp,nhmimp)
            end if
         
*         call tfremcse(iiseg,imcass,fracmc)

*         print '("tftcre : ++++ is,nh,imc,nhm,iass,f ",5i4,x,f7.2)'
*     +          ,iiseg,nh_PC,imc,nhmimp,imcass,fracmc

***         if(imcass.ne.muon1.and.imcass.ne.muon2) go to 10!select golden mu+-
#endif

         call tfclr()           ! clear p.r. buffer
         begin_ft = 1

#ifdef NEWNAV
         call tftcsen(iiseg,ift1,ift2,istat)    ! seed
#else
         call tftcse(iiseg,ift1,ift2,istat)    ! seed
#endif

*         print '("tftcre : ---- muon seg=",i4," istat=",i2)',iiseg,istat
*         print '("tftcre : ---- muon seg=",i4," mcmu,fr= ",3i4,x,f8.3)'
*     +         ,iiseg,imcass,muon1,muon2,fracmc

          if(istat.lt.0) then
            print *,'tftcre: ==== tftcse for seg  ift1,ift2,istat=',
     +              iiseg,ift1,ift2,istat
          end if

         direction = +1

         nca_prep = ift2        ! store new endpointer

         l_2dx = .false.
         l_2dy = .false.
         l_mag = .true.
         begin_ft = nca_prep + 1
         istat = 0


#ifdef NEWNAV
         call tftcpron(ift1,+1,istat)
#else
         call tftcpro(ift1,+1,istat)
#endif

*         print *,' tftcre: tftcpro returns istat=',istat
         if (istat.ge.0) then
         elseif (istat.le.-100) then
            go to 999           ! no further propagation
         elseif (istat.le.-1) then
            go to 10            ! terminate branch
         endif

         if (diag_level.ge.2) then
            call tfl()
            print *,' after tftcpro,before tfbest'
            call tfwait()
         endif
         begin_ft = nca_prep + 1
         call tfbest()
         if (diag_level.ge.3) then
            call tfl()
            print *,' after tfbest'
            call tfwait()
         endif

*        **** store loop
 9       continue

         begin_store = nca_prep + 1

         do 40 ift=begin_store,nca_ft
            if (alive_ft(ift)) then
*               if (quality_ft(ift).lt.quality_TC_min
*     +         .or.nhit_ft(ift).lt.5 ) go to 40

**               print *,' ===== tftcre: ift=',ift,
**     +              ' quality=',quality_ft(ift),
**     +              ' cut=',quality_TC_min,
**     +              ' nhit=',nhit_ft(ift)
**               print *,' warning: quality cut removed'
               if (quality_ft(ift).lt.quality_TC_min) go to 40

               call tfstseg(ift)

               seg_PC_TC(NRSEG()) = iiseg
               seg_TC_PC(iiseg)   = NRSEG()
               seg_TC_PC(NRSEG()) = 0

#ifdef TC_TEST
               print '("tftcre : ========== stored iiseg,nseg ",2i4)'
     +                ,iiseg,NRSEG() 
*               call tfprhs(NRSEG())

              print '("tftcre : PC_TC,iiseg,irseg_cmp ",3i5 )'
     +             ,seg_PC_TC(iiseg),NRSEG()
     +             ,iand(irseg_cmp(iiseg),rsegc_trit)

#endif
               if (l_diag) call tfwait()

            endif
 40      continue

 10   continue                  !  end of loop on segments

*     ****  set RBEG <----> REND relation for TC-segments
       
      if(jrseg.gt.0) then
        if(NRSEG().gt.0) then
          do iiseg=1,NRSEG()
            if( IAND(irseg_cmp(iiseg),rsegc_trit).eq.rsegc_trit ) then
            
*              print '("tftcre : set relation RBEG-REND ",3i5 )'
*     +             ,seg_PC_TC(iiseg),iiseg,rsegc_trit

              call mmbrel(jrsrs,seg_PC_TC(iiseg),iiseg) ! set relation

            end if
          end do                     ! end of loop on segments
        end if
      end if

 999  end
