#ifndef _ANMATCHPOINT_HH_
#define _ANMATCHPOINT_HH_

#include <arte/arte.hh>
#include "marple/RcMatchPoint.hh"

#include <CLHEP/Utilities/fortran.h>


struct Rc99MatchComb 
{
  ArtePointer<RCCL> cluster;
  ArtePointer<RSEG> svdSegment;
  ArtePointer<RSEG> richSegment;

  ArtePointer<RSEG> SvdEcal;
  ArtePointer<RSEG> SvdRich;
  ArtePointer<RSEG> RichEcal;

  Rc99MatchComb() : cluster(0), svdSegment(0), richSegment(0),
    SvdEcal(0), SvdRich(0), RichEcal(0) {};

  Rc99MatchComb & operator = (const Rc99MatchComb & match) 
    {
      cluster = match.cluster;
      svdSegment = match.svdSegment;
      richSegment = match.richSegment;
      SvdEcal = match.SvdEcal;
      SvdRich = match.SvdRich;
      RichEcal = match.RichEcal;
      return *this;
    }

  int makeRTRA();

};
ostream & operator << (ostream & os, const Rc99MatchComb &rp);

struct Rc99MatchVector
{
  vector<Rc99MatchComb> points;

  Rc99MatchComb & operator[] (unsigned int ipoint) 
    {
      return points[ipoint];
    }

  // first submit SvdEcal, then SvdRich and then Ecal Rich

  int addMatch( ArtePointer<RSEG> match );

  int addSvdEcal(   ArtePointer<RSEG> svdEcal); 
  int addRichEcal(  ArtePointer<RSEG> richEcal );
  int addSvdRich(   ArtePointer<RSEG> svdRich );

};


#endif
