
// *****************************************************************************
//
// source:    rcClassJPSIEE.C
//
// type:      source code
//
// created:   20 Jun 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassJPSIEE
//
// called by: rcClassify
//
// purpose:   check for J/Psi -> e+e- event
//
// hints:     do NOT set flagdst here!
//
// changes:
// 20 Jun 2000 (AG) creation
//
// *****************************************************************************

// standard includes

// ARTE includes
#include "arte/arte.hh"

// externals
extern int rcSelectTracksStatus;

//
// function code
//
int
rcClassJPSIEE()
{
  // check track selection
  if( !rcSelectTracksStatus ) return 0;
  
  // loop over tracks  
  for( ArteTable<RTRA>::iterator rtra = ArteTable<RTRA>::begin();
       rtra != ArteTable<RTRA>::end();
       ++rtra ){
    
    if( (*rtra)->fit == 2 ) return 1; // event found
  }

  // default return  
  return 0;
}
