
// *****************************************************************************
//
// source:    rcClassJPSIMM.C
//
// type:      source code
//
// created:   20 Jun 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassJPSIMM
//
// called by: rcClassify
//
// purpose:   check for J/Psi -> mu+mu- event
//
// hints:     do NOT set flagdst here!
//            muonjpsi: <0 not selected
//                      =0 selected
//                      >0 mass of candidate 
//
// changes:
// 20 Jun 2000 (AG) creation
//  6 Jul 2000 (AG) added FORTRAN function muonjpsi_()
//  7 Jul 2000 (AG) renamed muonjpsi_() to rcmuonjpsi_()
//
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// globals
float massJPSIMM = 0;

// prototypes
extern "C" float rcmuonjpsi_();

//
// function code
//
int
rcClassJPSIMM()
{
  // inits
  int rc = 0;

  // invoke J/Psi -> mu+mu- finder
  ARTE_mark( "rcmuonjpsi_", 0 );
  massJPSIMM = rcmuonjpsi_();
  if( massJPSIMM < 0 ){
    rc = 0;
  }
  else {
    rc = 1;
  }

  return rc;
}
