// *****************************************************************************
//
// source:    L3_VTtypes.C
//
// type:      source code
//
// created:   06 Dec 1999
//
// author:    Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// symbol:    
//
// changes:
//
// *****************************************************************************

#include <iostream.h>
#include "L3_VTtypes.hh"

ostream & operator << (ostream& os, const TrackParameter& t)
{
  os << "{(" << t.ax << ',' << t.ay << ")("
     << t.bx << ',' << t.by << ")," << t.moment << '}';
  return os;
}


ostream & operator << (ostream& os, const TCovMatrix& c)
{
  for( int j=0; j<5; j++ ) {
    for( int k=0; k<5; k++ ) {
      os << c.a[k][j] << ' ';
    }
    os << endl;
  }
  return os;
}

ostream & operator << (ostream& os, const PCovMatrix& c)
{
  for( int j=0; j<3; j++ ) {
    for( int k=0; k<3; k++ ) {
      os << c.a[k][j] << ' ';
    }
    os << endl;
  }
  return os;
}


ostream & operator << (ostream& os, const Point& p)
{
  os << '(' << p.x << ',' << p.y << ',' << p.z << ')';
  return os;
}


//void VtList::print()
//{
//  cout << "VtList: " << l << endl;
//  for( int i=0; i<l; i++ ) {
//    cout << vttrbf_.p[i] << endl;
//    cout << vttrbf_.v[i] << endl;
//    cout << endl;
//  }
//}


int matrix_pack[5][5] = {
  {  0, 1, 3, 6,10},
  {  1, 2, 4, 7,11},
  {  3, 4, 5, 8,12},
  {  6, 7, 8, 9,13},
  { 10,11,12,13,14}
};
