*
*-- Author :    Vik   11/11/98
*

      SUBROUTINE TRD_SEED

**********************************************************************
*
* Description: for initial step is determinated "seed" by 
*
*              matrix (5 straw X 4 rows) in each TRD bloks.
*
* Called from: TRD_REC
*
* 
*
* Arguments: none
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      DOUBLE PRECISION SUM_X, SUM_Z, SUM_X_Z, SUM_Z_2, A, B     
      REAL X_HELP, Z_HELP, DELTA_X, DELTA_Z, TAN_XZ, X1_SEED,
     +     Z1_SEED, TAXZ_SEED, DEL_Z, X4_SEED, Z4_SEED,TXZ4_SEED,
     +     X_TRD_SEED, Z_TRD_SEED, TNXZ_TRD_SEED, Y_TRD_SEED,
     +     TNYZ_TRD_SEED, Y_HELP, Y4_SEED, Y1_SEED,X_BL_LEFT, 
     +     Z_BL_ST, Y_BL_LT, Y_BL_RT, X_SD, Z_SD, Z_NEW, X_NEW,
     +     D_STRAW, X_BL_RT

c,A,B,
c     +     Z_NEW, X_NEW, D_STRAW, SUM_X, SUM_Z, SUM_X_Z, SUM_Z_2

      INTEGER ME_HELP, N_BLOK, N_ROW, N_STRAW, HELP_MATR, N_MATR, N_MAX,
     +        N_MR, N_ROW_H, N_ROW_2, 
     +        N_MR_SEED, N1_SEED, N_VAR, N_MR_1, N_VAR1,
     +        N_MR_2, N_VAR2, NB4_SEED, NB_TRD_SEED, N_ROW_1,
     +        N_STR_1, N_STR_2,
     +        N_STR_NEW, N_R1, N_R2, N_R3, N_R4, N_S1, N_S2, N_K,
     +        PARAM_2, N_MR_CH

      COMMON /TRD_HLP/ X_HELP, Y_HELP, Z_HELP, ME_HELP
      COMMON /TRD_SD/ X_TRD_SEED, Y_TRD_SEED, Z_TRD_SEED, TNXZ_TRD_SEED,
     +                TNYZ_TRD_SEED, NB_TRD_SEED, N_MATR
      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT

      PARAMETER (N_MAX = 1000, N_K = 15)

      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)
      DIMENSION ME_HELP(12,4,78), X_HELP(12,4,78), Z_HELP(12,4,78)
      DIMENSION Y_HELP(12,4,78), Y1_SEED(N_MAX,N_K)
      DIMENSION HELP_MATR(N_MAX,4,5), TAXZ_SEED(N_MAX,N_K)
      DIMENSION X1_SEED(N_MAX,N_K),Z1_SEED(N_MAX,N_K),N1_SEED(N_MAX,N_K)
      DIMENSION X4_SEED(N_MAX,N_K),Z4_SEED(N_MAX,N_K)
      DIMENSION TXZ4_SEED(N_MAX,N_K)
      DIMENSION X_TRD_SEED(N_MAX,N_K),Y_TRD_SEED(N_MAX,N_K)
      DIMENSION Z_TRD_SEED(N_MAX,N_K), Y4_SEED(N_MAX,N_K)
      DIMENSION TNXZ_TRD_SEED(N_MAX,N_K), TNYZ_TRD_SEED(N_MAX,N_K)
      DIMENSION NB_TRD_SEED(N_MAX,N_K)
      DIMENSION NB4_SEED(N_MAX,N_K)
      DIMENSION X_SD(5), Z_SD(5)
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
      CALL VZERO(X_SD,5)
      CALL VZERO(Z_SD,5)
C
      CALL VZERO(HELP_MATR,20000)
C
      PARAM_2 = N_MAX*N_K
C
      CALL VZERO(X1_SEED, PARAM_2)
      CALL VZERO(Y1_SEED, PARAM_2)
      CALL VZERO(Z1_SEED, PARAM_2)
      CALL VZERO(TAXZ_SEED, PARAM_2)
      CALL VZERO(N1_SEED, PARAM_2)
      CALL VZERO(X4_SEED, PARAM_2)
      CALL VZERO(Y4_SEED, PARAM_2)
      CALL VZERO(TXZ4_SEED, PARAM_2)
      CALL VZERO(NB4_SEED, PARAM_2)
      CALL VZERO(X_TRD_SEED, PARAM_2)
      CALL VZERO(Y_TRD_SEED, PARAM_2)
      CALL VZERO(Z_TRD_SEED, PARAM_2)
      CALL VZERO(TNXZ_TRD_SEED, PARAM_2)
      CALL VZERO(NB_TRD_SEED, PARAM_2)
C
      N_MATR = 0
      DEL_Z = 2.3125
      D_STRAW = 0.61
C
         DO N_BLOK = 1, 12
            DO N_STRAW = 1, 78
               DO N_ROW = 1, 4
                  IF(ME_HELP(N_BLOK,N_ROW,N_STRAW).NE.0) THEN
C
                     N_MATR  = N_MATR + 1
C
                     DO N_ROW_H = 1, 4
                     HELP_MATR(N_MATR,N_ROW_H,1) = N_BLOK*10000 + 
     +                                      N_ROW_H*100 + (N_STRAW - 2)
                     HELP_MATR(N_MATR,N_ROW_H,2) = N_BLOK*10000 + 
     +                                      N_ROW_H*100 + (N_STRAW - 1)
                     HELP_MATR(N_MATR,N_ROW_H,3) = N_BLOK*10000 + 
     +                                      N_ROW_H*100 + (N_STRAW - 0)
                     HELP_MATR(N_MATR,N_ROW_H,4) = N_BLOK*10000 + 
     +                                      N_ROW_H*100 + (N_STRAW + 1)
                     HELP_MATR(N_MATR,N_ROW_H,5) = N_BLOK*10000 + 
     +                                      N_ROW_H*100 + (N_STRAW + 2)
                     END DO
C
                  END IF
               END DO
            END DO
         END DO
C
         DO N_MR = 1, N_MATR
C
            N_MR_SEED = 0
C
            N_ROW_1   = 1
            N_STR_1   = 3
C
            N_BLOK    = INT(HELP_MATR(N_MR,N_ROW_1,N_STR_1)/10000)
            N_R1   = INT((HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                      10000*N_BLOK) /100)
            N_S1 = HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                    N_BLOK*10000 - N_R1*100
C
            IF(ME_HELP(N_BLOK,N_R1,N_S1).NE.0) THEN
C
               N_ROW_2 = 4
C
               DO N_STR_2 = 1, 5
C
                  N_R2   = INT((HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                      10000*N_BLOK) /100)
                  N_S2 = HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                    N_BLOK*10000 - N_R2*100                  
C
                IF(ME_HELP(N_BLOK,N_R2,N_S2).NE.0) THEN
C
                   DELTA_Z = Z_HELP(N_BLOK,N_R2,N_S2) - 
     +                       Z_HELP(N_BLOK,N_R1,N_S1)
                   DELTA_X = X_HELP(N_BLOK,N_R2,N_S2) - 
     +                       X_HELP(N_BLOK,N_R1,N_S1) 
                   TAN_XZ = DELTA_X/DELTA_Z
C
                   X_SD(N_R1) = X_HELP(N_BLOK,N_R1,N_S1)
                   Z_SD(N_R1) = Z_HELP(N_BLOK,N_R1,N_S1)
                   X_SD(N_R2) = X_HELP(N_BLOK,N_R2,N_S2)
                   Z_SD(N_R2) = Z_HELP(N_BLOK,N_R2,N_S2)
C
                   Z_NEW = Z_SD(N_R2) - DEL_Z
                   X_NEW = X_SD(N_R2) - TAN_XZ*DEL_Z
C
                   N_R3 = N_R2 - 1
C
            N_STR_NEW = INT((X_NEW - X_BL_LEFT(N_BLOK,N_R3))
     +                         /D_STRAW) + 1
C
                   IF(ME_HELP(N_BLOK,N_R3,N_STR_NEW).NE.0) THEN
C
                   X_SD(N_R3) = X_HELP(N_BLOK,N_R3,N_STR_NEW)
                   Z_SD(N_R3) = Z_HELP(N_BLOK,N_R3,N_STR_NEW)
C
                     SUM_X = X_SD(N_R1) + X_SD(N_R2) +
     +                       X_SD(N_R3)
                     SUM_Z = Z_SD(N_R1) + Z_SD(N_R2) +
     +                       Z_SD(N_R3)
                    SUM_X_Z= X_SD(N_R1)*Z_SD(N_R1) + 
     +                       X_SD(N_R2)*Z_SD(N_R2) +
     +                       X_SD(N_R3)*Z_SD(N_R3)
                    SUM_Z_2= Z_SD(N_R1)*Z_SD(N_R1) + 
     +                       Z_SD(N_R2)*Z_SD(N_R2) +
     +                       Z_SD(N_R3)*Z_SD(N_R3) 
C
                     A = (3*SUM_X_Z - SUM_Z*SUM_X)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
                     B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
C
                     Z_NEW = Z_SD(N_R3) - DEL_Z
                     X_NEW = A*Z_NEW + B
C
                     N_R4 = N_R3 - 1
C
                     N_STR_NEW = INT((X_NEW - 
     +                      X_BL_LEFT(N_BLOK,N_R4)) /D_STRAW) + 1
C
                     IF(ME_HELP(N_BLOK,N_R4,N_STR_NEW).NE.0) THEN
C
                      X_SD(N_R4) = X_HELP(N_BLOK,N_R4,N_STR_NEW)
                      Z_SD(N_R4) = Z_HELP(N_BLOK,N_R4,N_STR_NEW)
C
                     SUM_X = X_SD(N_R1) + X_SD(N_R2) +
     +                       X_SD(N_R3) + X_SD(N_R4)
                     SUM_Z = Z_SD(N_R1) + Z_SD(N_R2) +
     +                       Z_SD(N_R3) + Z_SD(N_R4)
                    SUM_X_Z= X_SD(N_R1)*Z_SD(N_R1) + 
     +                       X_SD(N_R2)*Z_SD(N_R2) +
     +                       X_SD(N_R3)*Z_SD(N_R3) +
     +                       X_SD(N_R4)*Z_SD(N_R4)
                    SUM_Z_2= Z_SD(N_R1)*Z_SD(N_R1) + 
     +                       Z_SD(N_R2)*Z_SD(N_R2) +
     +                       Z_SD(N_R3)*Z_SD(N_R3) +
     +                       Z_SD(N_R4)*Z_SD(N_R4) 
C
                     A = (4*SUM_X_Z - SUM_Z*SUM_X)/(4*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
                     B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(4*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
C
                     N_MR_SEED = N_MR_SEED + 1
C
                     Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                     X4_SEED(N_MR, N_MR_SEED) = A*Z_SD(N_R2) + B
                     Y4_SEED(N_MR, N_MR_SEED) = 0.
                     TXZ4_SEED(N_MR, N_MR_SEED) = A
                     NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C
                     ELSE              ! N_ROW_4,N_STR_NEW.EQ.1
C
                     N_MR_SEED = N_MR_SEED + 1
C
                     Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                     X4_SEED(N_MR, N_MR_SEED) = A*Z_SD(N_R2) + B
                     Y4_SEED(N_MR, N_MR_SEED) = 0.
                     TXZ4_SEED(N_MR, N_MR_SEED) = A
                     NB4_SEED(N_MR, N_MR_SEED) = N_BLOK                   
C
                     END IF            ! N_ROW_4,N_STR_NEW.EQ.1
C
                   ELSE                ! N_ROW_3,N_STR_NEW).EQ.1
C
*   BYL NA 1, 4, NET NA 3
C
                      Z_NEW = Z_HELP(N_BLOK,N_R2,N_S2) - 2.*DEL_Z
c                      X_NEW = X_HELP(N_BLOK,N_R2,N_S2) + TAN_XZ*
c     +                        2.*DEL_Z
                      X_NEW = X_HELP(N_BLOK,N_R2,N_S2) - TAN_XZ*
     +                        2.*DEL_Z
C
                      N_R4 = N_R2 - 2
C
                      N_STR_NEW = INT((X_NEW - 
     +                      X_BL_LEFT(N_BLOK,N_R4)) /D_STRAW) + 1
C
                     IF(ME_HELP(N_BLOK,N_R4,N_STR_NEW).NE.0) THEN
C
                      X_SD(N_R4) = X_HELP(N_BLOK,N_R4,N_STR_NEW)
                      Z_SD(N_R4) = Z_HELP(N_BLOK,N_R4,N_STR_NEW)
C
                     SUM_X = X_SD(N_R1) + X_SD(N_R2) +
     +                       X_SD(N_R4)
                     SUM_Z = Z_SD(N_R1) + Z_SD(N_R2) +
     +                       Z_SD(N_R4)
                    SUM_X_Z= X_SD(N_R1)*Z_SD(N_R1) + 
     +                       X_SD(N_R2)*Z_SD(N_R2) +
     +                       X_SD(N_R4)*Z_SD(N_R4)
                    SUM_Z_2= Z_SD(N_R1)*Z_SD(N_R1) + 
     +                       Z_SD(N_R2)*Z_SD(N_R2) +
     +                       Z_SD(N_R4)*Z_SD(N_R4) 
C
                     A = (3*SUM_X_Z - SUM_Z*SUM_X)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
                     B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
C
                     N_MR_SEED = N_MR_SEED + 1
C
                     Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                     X4_SEED(N_MR, N_MR_SEED) = A*Z_SD(N_R2) + B
                     Y4_SEED(N_MR, N_MR_SEED) = 0.
                     TXZ4_SEED(N_MR, N_MR_SEED) = A
                     NB4_SEED(N_MR, N_MR_SEED) = N_BLOK 
C
                     ELSE
C
*   1 - 4 I VSE TOL'KO ETI
C
                      N_MR_SEED = N_MR_SEED + 1 
C
                      Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                      X4_SEED(N_MR, N_MR_SEED) = X_SD(N_R2)
                      Y4_SEED(N_MR, N_MR_SEED) = 0.
                      TXZ4_SEED(N_MR, N_MR_SEED) = TAN_XZ
                      NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C                     
                     END IF
C
                   END IF              ! N_ROW_3,N_STR_NEW.EQ.1
C
                END IF                 ! N_ROW_2,N_STR_2.EQ.1
C
               END DO                  ! N_STR_2 = 1, 5
c
            END IF                     ! N_ROW_1,N_STR_1.EQ.1
C
            N_ROW_1 = 1
            N_STR_1 = 3
C
            N_BLOK    = INT(HELP_MATR(N_MR,N_ROW_1,N_STR_1)/10000)
            N_R1   = INT((HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                      10000*N_BLOK) /100)
            N_S1 = HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                    N_BLOK*10000 - N_R1*100
C
            IF(ME_HELP(N_BLOK,N_R1,N_S1).NE.0) THEN  
C
               N_ROW_2 = 3 
C
               DO N_STR_2 = 1, 5
C
                  N_R2   = INT((HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                      10000*N_BLOK) /100)
                  N_S2 = HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                    N_BLOK*10000 - N_R2*100
C
                 IF(ME_HELP(N_BLOK,N_R2,N_S2).NE.0) THEN 
C
                   DELTA_Z = Z_HELP(N_BLOK,N_R2,N_S2) -
     +                       Z_HELP(N_BLOK,N_R1,N_S1)
                   DELTA_X = X_HELP(N_BLOK,N_R2,N_S2) -
     +                       X_HELP(N_BLOK,N_R1,N_S1)
                   TAN_XZ = DELTA_X/DELTA_Z
C
                   X_SD(N_R1) = X_HELP(N_BLOK,N_R1,N_S1)
                   Z_SD(N_R1) = Z_HELP(N_BLOK,N_R1,N_S1)
                   X_SD(N_R2) = X_HELP(N_BLOK,N_R2,N_S2)
                   Z_SD(N_R2) = Z_HELP(N_BLOK,N_R2,N_S2)
C
                   Z_NEW = Z_SD(N_R2) - DEL_Z
                   X_NEW = X_SD(N_R2) - TAN_XZ*DEL_Z
c                   X_NEW = X_SD(N_R2) + TAN_XZ*DEL_Z
C
                   N_R3 = N_R2 - 1
C
         N_STR_NEW = INT((X_NEW - X_BL_LEFT(N_BLOK,N_R3))
     +                         /D_STRAW) + 1
C
                   IF(ME_HELP(N_BLOK,N_R3,N_STR_NEW).NE.0) THEN
C
                      Z_SD(N_R3) = Z_HELP(N_BLOK,N_R3,N_S2)
                      X_SD(N_R3) = X_SD(N_R2) + DEL_Z*TAN_XZ
C
                     SUM_X = X_SD(N_R1) + X_SD(N_R2) +
     +                       X_SD(N_R3)
                     SUM_Z = Z_SD(N_R1) + Z_SD(N_R2) +
     +                       Z_SD(N_R3)
                    SUM_X_Z= X_SD(N_R1)*Z_SD(N_R1) + 
     +                       X_SD(N_R2)*Z_SD(N_R2) +
     +                       X_SD(N_R3)*Z_SD(N_R3)
                    SUM_Z_2= Z_SD(N_R1)*Z_SD(N_R1) + 
     +                       Z_SD(N_R2)*Z_SD(N_R2) +
     +                       Z_SD(N_R3)*Z_SD(N_R3) 
C
                     A = (3*SUM_X_Z - SUM_Z*SUM_X)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
                     B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
C
                      N_MR_SEED = N_MR_SEED + 1 
C
                      Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2) + DEL_Z
                      X4_SEED(N_MR, N_MR_SEED) = A*
     +                                Z4_SEED(N_MR, N_MR_SEED) + B
                      Y4_SEED(N_MR, N_MR_SEED) = 0.
                      TXZ4_SEED(N_MR, N_MR_SEED) = A
                      NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C
                   ELSE
C
                      N_MR_SEED = N_MR_SEED + 1 
C
                      Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_ROW_2) + DEL_Z
                      X4_SEED(N_MR, N_MR_SEED) = X_SD(N_ROW_2) +
     +                                                   DEL_Z*TAN_XZ
                      Y4_SEED(N_MR, N_MR_SEED) = 0.
                      TXZ4_SEED(N_MR, N_MR_SEED) = TAN_XZ
                      NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C
                   END IF
                END IF
               END DO
C
            END IF
C
            N_ROW_1 = 2
            N_STR_1 = 3
C
            N_BLOK    = INT(HELP_MATR(N_MR,N_ROW_1,N_STR_1)/10000)
            N_R1   = INT((HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                      10000*N_BLOK) /100)
            N_S1 = HELP_MATR(N_MR,N_ROW_1,N_STR_1) - 
     +                    N_BLOK*10000 - N_R1*100
C
            IF(ME_HELP(N_BLOK,N_R1,N_S1).NE.0) THEN  
C
               N_ROW_2 = 4 
C
               DO N_STR_2 = 1, 5
C
                  N_R2   = INT((HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                      10000*N_BLOK) /100)
                  N_S2 = HELP_MATR(N_MR,N_ROW_2,N_STR_2) - 
     +                    N_BLOK*10000 - N_R2*100
C
                 IF(ME_HELP(N_BLOK,N_R2,N_S2).NE.0) THEN
C
                   DELTA_Z = Z_HELP(N_BLOK,N_R2,N_S2) -
     +                       Z_HELP(N_BLOK,N_R1,N_S1)
                   DELTA_X = X_HELP(N_BLOK,N_R2,N_S2) -
     +                       X_HELP(N_BLOK,N_R1,N_S1)
                   TAN_XZ = DELTA_X/DELTA_Z
C
                   X_SD(N_R1) = X_HELP(N_BLOK,N_R1,N_S1)
                   Z_SD(N_R1) = Z_HELP(N_BLOK,N_R1,N_S1)
                   X_SD(N_R2) = X_HELP(N_BLOK,N_R2,N_S2)
                   Z_SD(N_R2) = Z_HELP(N_BLOK,N_R2,N_S2)
C
                   Z_NEW = Z_SD(N_R2) - DEL_Z
                   X_NEW = X_SD(N_R2) - TAN_XZ*DEL_Z
c                   X_NEW = X_SD(N_R2) + TAN_XZ*DEL_Z
C
                   N_R3 = N_R2 - 1
C
           N_STR_NEW = INT((X_NEW - X_BL_LEFT(N_BLOK,N_R3))
     +                         /D_STRAW) + 1
C
                   IF(ME_HELP(N_BLOK,N_R3,N_STR_NEW).NE.0) THEN
C
                     X_SD(N_R3) = X_HELP(N_BLOK,N_R3,N_STR_NEW)
                     Z_SD(N_R3) = Z_HELP(N_BLOK,N_R3,N_STR_NEW)
C
                     SUM_X = X_SD(N_R1) + X_SD(N_R2) +
     +                       X_SD(N_R3)
                     SUM_Z = Z_SD(N_R1) + Z_SD(N_R2) +
     +                       Z_SD(N_R3)
                    SUM_X_Z= X_SD(N_R1)*Z_SD(N_R1) + 
     +                       X_SD(N_R2)*Z_SD(N_R2) +
     +                       X_SD(N_R3)*Z_SD(N_R3)
                    SUM_Z_2= Z_SD(N_R1)*Z_SD(N_R1) + 
     +                       Z_SD(N_R2)*Z_SD(N_R2) +
     +                       Z_SD(N_R3)*Z_SD(N_R3) 
C
                     A = (3*SUM_X_Z - SUM_Z*SUM_X)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
                     B = (SUM_X*SUM_Z_2 - SUM_Z*SUM_X_Z)/(3*SUM_Z_2 -
     +                    SUM_Z*SUM_Z)
C
                     N_MR_SEED = N_MR_SEED + 1
C
                     Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                     X4_SEED(N_MR, N_MR_SEED) = X_SD(N_R2)
                     Y4_SEED(N_MR, N_MR_SEED) = 0.
                     TXZ4_SEED(N_MR, N_MR_SEED) = A
                     NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C
                     ELSE
C
                     N_MR_SEED = N_MR_SEED + 1
C
                     Z4_SEED(N_MR, N_MR_SEED) = Z_SD(N_R2)
                     X4_SEED(N_MR, N_MR_SEED) = X_SD(N_R2)
                     Y4_SEED(N_MR, N_MR_SEED) = 0.
                     TXZ4_SEED(N_MR, N_MR_SEED) = TAN_XZ
                     NB4_SEED(N_MR, N_MR_SEED) = N_BLOK
C
                     END IF
C
                 END IF
C
               END DO
C
            END IF
C
         END DO
C
         DO N_MR_1 = 1, N_MATR
            DO N_VAR1 = 1, 15
C
               N_MR_CH = N_MR_1 + 1
C
               DO N_MR_2 = N_MR_CH, N_MATR
                  DO N_VAR2 = 1, 15
                     IF(X4_SEED(N_MR_1,N_VAR1).EQ.
     +                  X4_SEED(N_MR_2,N_VAR2).AND.
     +                  TXZ4_SEED(N_MR_1,N_VAR1).EQ.
     +                  TXZ4_SEED(N_MR_2,N_VAR2)) THEN
C
                        X4_SEED(N_MR_2,N_VAR2) = 0.
                        Z4_SEED(N_MR_2,N_VAR2) = 0.
                        Y4_SEED(N_MR_2,N_VAR2) = 0.
                        TXZ4_SEED(N_MR_2,N_VAR2) = 0.
                        NB4_SEED(N_MR_2,N_VAR2)  = 0
C
                     END IF
                  END DO
               END DO
            END DO
         END DO
C
         DO N_MR = 1, N_MATR
            DO N_VAR = 1, 15
               IF(X4_SEED(N_MR,N_VAR).NE.0.) THEN
C
                  X_TRD_SEED(N_MR,N_VAR)    = X4_SEED(N_MR,N_VAR)
                  Y_TRD_SEED(N_MR,N_VAR)    = Y4_SEED(N_MR,N_VAR)  
                  Z_TRD_SEED(N_MR,N_VAR)    = Z4_SEED(N_MR,N_VAR)
                  TNXZ_TRD_SEED(N_MR,N_VAR) = TXZ4_SEED(N_MR,N_VAR)
                  TNYZ_TRD_SEED(N_MR,N_VAR) = 0.
                  NB_TRD_SEED(N_MR,N_VAR)   = NB4_SEED(N_MR,N_VAR) 
C
c              WRITE
c     +  (*,'(''MATR SEED==>'',3(1X,I5),3(1X,F8.3))')
c     +  N_MR, N_VAR, NB_TRD_SEED(N_MR,N_VAR), 
c     +  X4_SEED(N_MR,N_VAR), Z4_SEED(N_MR,N_VAR), 
c     +  TXZ4_SEED(N_MR,N_VAR)                   
               END IF
            END DO
         END DO
C
c      PRINT *,'STOP SEED for TRD'
C
*      STOP
C
 900  END

*********************************************************************
* End of TRD_SEED
************************************************************************
