*CMZ :          20/05/96  12.58.00  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       subroutine:   VTZTR(it1,it2,z1,z2)               R*8
c
c       input:    track indices it1, it2                 Int
c
c       output:   z1,z2                                  R*8
c                 longitudinal positions of closest approach
c
c-------------------------------------------------------------
c
      subroutine VTZTR(it1,it2,z1,z2)

      implicit none
#include "vt/vtdat.fi"

      integer it1, it2, i
      double precision 
     1  z1,z2

      double precision 
     1  a1(2), a2(2), a1a2, a1sq, a2sq, det
      double precision 
     1  db(2), dba1, dba2

      do  i = 1, 2
        a1(i) = p(i,it1)
        a2(i) = p(i,it2)
        db(i) = p(i+2,it2) - p(i+2,it1)
      enddo
      a1a2 = a1(1)*a2(1) + a1(2)*a2(2) +1.d0
      a1sq = a1(1)**2 + a1(2)**2 +1.d0
      a2sq = a2(1)**2 + a2(2)**2 +1.d0
      dba1 = db(1)*a1(1) + db(2)*a1(2)
      dba2 = db(1)*a2(1) + db(2)*a2(2)

      det = a1a2**2 - a1sq*a2sq
      det = 1.d0/det
      z1  = det*( a1a2*dba2 - a2sq*dba1 )
      z2  = det*( a1sq*dba2 - a1a2*dba1 )

      return
      end
